Introduction

Welcome to Total Access Detective!

Thank you for using Total Access Detective, the premiere database object comparison tool for Microsoft Access databases. Total Access Detective helps you determine exactly what is different between two objects in one database or between two databases.

Total Access Detective is developed by FMS, the world’s leading developer of Microsoft Access products. In addition to Total Access Detective, we offer a wide range of products for Microsoft Access developers, administrators, and users:

  • Total Access Analyzer (database documentation)

  • Total Access Admin (database maintenance control)

  • Total Access Components (ActiveX controls)

  • Total Access Emailer (email blaster)

  • Total Access Memo (rich text format memo fields)

  • Total Access Speller (spell checker)

  • Total Access Statistics (statistical analysis program)

  • Total Access Startup (version launcher)

  • Total Visual Agent (database maintenance and scheduling)

  • Total Visual CodeTools (code builders and managers)

  • Total Visual SourceBook (code library)

  • Total Zip Code Database (city and state lookup lists)

Visit our web site, fmsinc.com, for more information. We also offer Sentinel Visualizer, an advanced data visualization program that identifies relationships among people, places and events through link charts, geospatial mapping, timelines, social network analysis, etc. Visit our Sentinel Visualizer site for details.

Please make sure you sign up for our free email newsletter. This guarantees that you will be contacted in the event of news, upgrades, and beta invitations. Once again, thank you for selecting Total Access Detective.


Product Highlights

Welcome to Total Access Detective, the comparison wizard for Microsoft Access. Total Access Detective gives you the ability to compare any two objects or two databases for differences, simplifying the tracking of changes between versions. For multi-developer or multi-site environments, Total Access Detective detects differences between databases to ease the consolidation of modifications.

Total Access Detective determines all differences between objects, uncovering differences in properties, controls, fields, indexes, macro lines, and even module lines. Total Access Detective can even show data differences (new and modified records) between your tables, and combine the data into a new table. It also detects line-by-line differences between any two blocks of text.

Total Access Detective is fully integrated with Microsoft Access and is implemented as an easy-to-use Wizard. There are two ways to use the Wizard: comparing two objects in the current database (from the Access Add-ins menu), or comparing identically named objects in two databases (from the Windows Start menu).

See Also

  • Introduction

  • What Total Access Detective Detects

  • Enhancements in This Version

  • Enhancements from Previous Versions

  • Visit Our Web Site

  • Installation and Startup

  • Running Total Access Detective


What Total Access Detective Detects

Total Access Detective reveals the differences between any two Access objects. The type of difference depends on the type of objects compared. In general, only properties of identically named items (e.g. fields, controls, macro names, procedures) are compared. For instance, properties of fields are compared based on field name, not field order (which can vary if fields are added, deleted, or re-ordered). If an item exists in only one object, it is listed, but its properties are not listed as being different.

Tables, Fields, Indexes and Data

  • Fields: Compares field properties (such as name, order, data type, description, input mask, validation rule, etc.), and lists fields in one table and not the other.

  • Indexes: Compares index names, fields, sort order, primary, unique, ignore blanks, etc., and lists indexes in one table and not the other.

  • Data: Compares data in tables and queries with identical fields. For keyed tables it reveals new, modified, and deleted records. For un-keyed tables, it lists the first differing record. New options are available for comparing tables with different field names, field order, and un-keyed tables.

Queries

Compares query type, fields, parameters, and other properties. When comparing two queries, there is an option to compare their data.

Forms

Compares form properties, controls/control properties, and sections/section properties, and lists controls and sections in one form but not the other. Modules and Embedded macros are also compared. See Form and Report Comparison Options for details.

Reports

Compares report properties, controls/control properties, sections/section properties, and group level properties, and lists objects in one report but not the other. Modules and Embedded macros are also compared. See Form and Report Comparison Options for details.

Macros

Detects differences in macro commands, including arguments. If macro names (also known as sub-macros) exist, only identically named macro names are compared. Macro names in one macro but not the other are listed.

Total Access Detective does not perform a simple line-by-line comparison—if it used this approach and an extra line were added or deleted, all subsequent lines would be flagged as different. Instead, it uses a more intelligent algorithm to detect whether multiple lines of a macro were added or deleted, and only presents the block of differences.

Modules

Detects differences in module lines, and lists procedures in one module but not the other. The declarations sections and identically named procedures are compared line by line.

Like with macros, Total Access Detective does not perform a simple line-by-line comparison. It understands that blocks of code may be added or deleted, and only lists the block of code that differs rather than all the lines after the first difference. If lines of code are modified (rather than added or deleted), the code from both modules is shown for easy comparison. See Module Comparison Options for details.

Import/Export Specifications

Access 2007 introduced saved import and export specifications, which are compared in Access 2007 and later.

Text Comparison

Performs line-by-line comparison between any two blocks of text. The text may be from any source; simply retrieve it from a file or paste it into Total Access Detective for analysis. This feature is ideal for comparing module code stored outside your database, such as old versions or text files. You can analyze the text as plain text or perform module analysis to compare procedures. The results are similar to module analysis with a report for the differences and line-by-line printouts of the original text blocks. See Text Comparison for details.

Database Comparison

These additional items are analyzed for Database Comparisons:

Missing Objects

Objects in one database and not the other.

Permissions

Detects differences in security permissions.

Relations

Detects differences in table relationships, including linked fields, referential integrity settings, and relationship types.

Database Properties

Detects differences in database properties, and lists properties that exist in one database but not the other.

Library References

Detects different VBA library references.

See Also

  • Product Highlights

  • Enhancements in This Version

  • Enhancements from Previous Versions

  • Visit Our Web Site


Enhancements in This Version

The latest version of Total Access Detective includes many significant enhancements from the 2016 version:

Total Access Detective 2026 for Microsoft Access 2024/365

Total Access Detective 2026, version 26, supports Microsoft Access 2024/365 and Access 2021 and 2019. It is an enhancement from version 16 which was originally created for Access 2016.

Total Access Detective 2026 includes support for the 32 and 64-bit versions of Access. Microsoft does not allow both versions of Office to be installed on one machine. The Total Access Detective setup program detects the appropriate version and installs it on your machine.

Additional Versions

New X.6 releases were also created for older versions to include enhancements for their Access versions:

  • Version 16.6 for Access 2016

  • Version 15.6 for Access 2013

  • Version 14.6 for Access 2010

Supports New Controls introduced in Access 2019 and Later

Total Access Detective 2026 supports detecting differences among new control types such as Edge Browser, Modern Charts, and Web Browser.

Supports ACCDB Databases with BigInt and DateTime2 Columns

Total Access Detective 2026 compares the new, upgraded ACCDB databases that support SQL Server tables with BigInt and DateTime2 columns.

Filter Differences for Missing Fields, Controls, Sections and Groups

The object comparison results shows all the differences between two objects including every property. That can be overwhelming. A new checkbox filters the list to just the major differences:

Filter Table Differences to Just Fields in One Table But Not the Other

  • Tables: Fields and Indexes in one table and not the other:

  • Queries: Fields and Parameters in one query and not the other:

  • Forms: Controls and Sections in one form and not the other:

  • Reports: Controls, Groups and Sections in one report and not the other:

Launch Database Comparison from the Add-in

The Database Comparison program is normally launched from a shortcut on the Windows Start menu.

Users sometimes launch Total Access Detective from the add-ins menu intending to do this. The add-in is designed to compare objects in your currently opened database, rather than compare databases.

New Compare Database button on the Total Access Detective Add-in form

The new [Compare Databases] button launches the Database Comparison program and closes the add-in.

Two Database Comparison Results Form

The form for comparing the Two Database Comparison results is simplified and enhanced. The Overview, Unmatched Objects, and Errors buttons are moved to the top making it easier to understand the overall differences before getting into the details of the Object, Macro, Module and Data Differences. Unnecessary text below each button was removed.

Two Database Comparison Results Form

The Browse button [...] to choose another database comparison is moved to the left (used to be on the far right with a file open graphic):

Two Database Comparison Overview Form

The Overview provides a summary of the differences between the two databases. It adds a tab with a summary of the differences by object type:

Database Comparison Overview Form with Two Summary Tabs

This lets you easily see the types of objects where you have the most differences. See Results Overview for details.

Two Database Comparison Object Differences

The Object Differences form has a filter on the top with new combo boxes to more easily filter the list by object type and name (if no name is selected, all the differences for the selected type are shown):

Filter by Object Type and/or Name

This makes it much easier to select the object type and/or specific object to see their differences. See Database Comparison Object Differences for details.

Two Database Comparison Macro and Module Differences

Viewing the Macro and Module differences now has combo boxes to choose by object type and name:

New Buttons

Two Object Comparison Swap Button

The Two Object Comparison selection has a new Swap button to flip Objects 1 and 2:

New Swap Button Flips Object Names

The Swap button also refreshes the combo box lists if any objects were added or deleted since the object type was selected.

Text Comparison with Clear and Replace Buttons

The Text Comparison form lets you find differences between two blocks of text that you paste in or retrieve from files. Two new buttons let you update both blocks of text.

[Clear All] to clear both, and [Refresh All] to update both if they are from files on disk. See Text Comparison for details.

About Form to Check for Updates

The About form adds a new [Check for Updates] button to see if you have the latest version installed.

User Interface Enhancements

When viewing Two Object comparison results, the results were previously in the Objects tab. Now the tab name is the compared object type: Table, Query, Form, Report, Macro, Module, etc.

Caption of First Tab is the Object Type of the Compared Objects

Forms have taller footers and wider buttons. Many button graphics are updated with more modern images and the new Access icon, like the Export button:

The Unmatched Objects form shows the two lists with even widths when resized.

Updated User Manual and Help File

User manual and help file are updated for the latest version and enhancements.

See Also

  • Product Highlights

  • What Total Access Detective Detects

  • Enhancements from Previous Versions

  • Visit Our Web Site


Enhancements from Previous Versions

Prior versions include these enhancements:

Version 16 for Microsoft Access 2016, Version 15 for 2013, and Upgrades for Earlier Access Versions

New versions are available:

  • Version 16.0 for Microsoft Access 2016

  • Version 15.5 for Microsoft Access 2013

  • Version 14.5 for Microsoft Access 2010

  • Version 12.9 for Microsoft Access 2007

  • Version 11.9 for Microsoft Access 2003

Each version supports the different property values, macro actions and VBA changes for its Access version.

Support for 32 and 64 bit Versions of Microsoft Access

Total Access Detective includes two programs in one to support the 32 and 64 bit versions of Microsoft Access 2016, 2013 and 2010. Microsoft does not allow both versions of Office to be installed on one machine. The Total Access Detective setup program detects the appropriate version and installs it on your machine.

Module and Text Comparison Option to Ignore Line Numbers

Total Access Detective compares module code for differences. Module code may include line numbers to help with error handling to pinpoint exactly which line of code is crashing.

When comparing VBA code, you may have code that’s numbered and not numbered or two modules numbered differently. If you are only interested in the VBA that changed and not the line numbers, Total Access Detective offers a new option to compare your code and ignore any differences with line numbers:

New Option to Exclude Line Numbers

Search Bar to Filter Objects and Properties by Name

Similar to the search bar on the Microsoft Access navigation pane, Total Access Detective includes a Name Filter to simplify selecting objects when comparing databases:

Name Filter for Selecting Objects

The [Select All] and [Cancel All] buttons work on the filtered list.

Similarly, the Name Filter is also available for Property names in the Property Selection feature:

Name Filter on Property List

After comparing two databases, when viewing the Object Differences, the filter for the object names and properties also has the Name filter.

See and Filter Tables based on Whether it’s Linked

When comparing two databases, a list of identically named objects is displayed to select them for detailed comparison. Tables are now displayed with information on whether they are linked or not, and a filter is available to easily see the differences:

The filter options are:

Table Filter Options

  • All: No Filter

  • Local: Both tables are local (exist in their respective database)

  • Linked: Both tables are linked to other databases

  • Mixed: One is local and the other is linked

Procedures with Differences List

When comparing two modules, a new tab is shown for the procedures with differences. The detail of the differences remains in the main tab, but now there’s a summary list of procedures that are different:

New Procedures with Differences Tab when Comparing Text

New Procedures with Differences Tab when Comparing Two Modules

New Procedures with Differences Tab when Comparing Modules in Two Databases

In addition to viewing the data in the tab, corresponding export and reports are available.

Data Macro Comparison

Data macros in ACCDBs (Access 2010 and later) are detected. Data macros in one database and not the other are identified. Identically named data macros are compared for code differences.

Datasheet Column Widths are Saved

If you resize datasheet columns while viewing the Total Access Detective results, your column widths are preserved the next time you reopen the form.

Two Database Comparison User Interface

Object Selection Screen Enhancements

  • Conditional formatting shows which object was more recently modified

  • Ability to filter and sort on status column

  • Status column offers information explaining its values

Property filter form is resizable

International Users

For our international customers, when you first run Total Access Detective, it defaults to A4 paper size (rather than US Letter) if your default printer uses A4 paper.

Improved User Interface

  • For beginners, the two object comparison add-in mentions launching the two database comparison Wizard if you're in the wrong Wizard

  • Sample database is launched with splash screen

  • Font size increased for some screens

Improved Setup

Setup program enhanced to upgrade existing installation and Modify, Repair and Remove from Control Panel.

Updated Documentation

Updated user manual and help file.

Version 14 for Microsoft Access 2010

The new properties, macro actions, and VBA code syntax introduced in Access 2010 are supported for difference detection.

Microsoft Access 2010 Support for 32 and 64 bit Versions

Total Access Detective 2010 includes two programs in one to support the 32 and 64 bit versions of Microsoft Office 2010.

Embedded Macro Line-by-Line Comparison

Embedded macros on forms and reports are now compared on a line-by-line basis similar to how regular macros are compared. Previously, the entire embedded macro property was compared without the “smart” comparison that identifies new or deleted lines within the macro code. To support this, the results now have a new Embedded Macros tab when differences exist. For two database comparisons, this is in the Object Differences screen. Three new reports are added to show the differences between the macros, as well as the embedded macro code from each object or database.

Identical Procedures Listed for Module Comparisons

In addition to listing the modules lines that are different, a new list of identical procedures is generated. This lets you easily confirm which procedures did not change. The identical procedures are shown on a new Identical Procedures tab after the Module Differences tab. This applies to comparing two objects, two databases, and two blocks of text. Two reports are provided for printing the list: Object Comparison Identical Procedures and Database Comparison Identical Procedures. These reports can also be exported.

Identical Procedures between Two Modules

Data Comparison Option to Ignore Case

A new option is available to ignore case between fields. This is set under the Data Comparison Options, Field Comparison tab. Check the Ignore Case option if you want case insensitive comparisons of your data.

Ignore Blank Lines and Comments when Comparing Modules

Additional options are available to compare modules by ignoring blank lines and comments. This is in addition to ignoring differences due to case or indentations. These options are now available under Text Options:

New Text Comparison Options

When Ignore Comments is selected, any comment lines or comments at the end of a line are ignored and just the VBA code is compared.

Ignore Blank Lines and Comments when Comparing Two Blocks of Text

Similar to module comparison, you can also ignore blank lines and comments when comparing two blocks of text.

Exclude Properties from Comparison

You now have the ability to exclude properties from the comparisons. For instance, if you don’t care about the LastUpdated property of objects, you can exclude it from comparison. This is particularly useful when a property you don’t care about is the only difference between objects

Specify Storage Database Name for Database Comparisons

When comparing two databases, you can now specify the name of the database containing the results. This lets you keep an unlimited number of database comparison results. You can specify the database name on the last page of the wizard. If the name already exists, information on what it contains is displayed.

Specify Storage Folder

By default, Total Access Detective saves its files in a user folder. You can now change this location to another folder when you specify the storage folder for the results.

Specify Where to Store the Database Comparison Results

Viewing Different Database Comparisons

From the main screen when viewing the results of database comparisons, a new button to open the documentation is available. Easily retrieve a previously saved result. This lets you keep and manage multiple copies of the database comparison results.

Command Line Can Specify Storage Database Name

When invoking Total Access Detective from a command line to compare two databases, you can now add an additional parameter specifying the storage database name. This lets you automate the generation of multiple database comparisons.

Improved Ease of Use

Two Database Comparison Retains Previous Results

Previously, if you were running the two database comparison and selected two databases, the existing results were no longer available. This is now separated so the results are available until you overwrite them.

Two Database Comparison Does Not Select System Tables

If your database object list has System Objects turned on, the system objects are listed for selection. Previously, all objects were automatically selected for comparison. Now, the system tables are not selected.

Two Database Comparison Exports Data to another Database

When performing text comparisons in the two database comparison feature, you can now export the results to another database.

Reports List is Full Screen with More Information

The display of available reports is full screen with a description of each report to make it easier to understand and select.

Manage User Access Control Rights

Total Access Detective respects your login rights. By default, it is installed in your user folder, it updates registry settings in your user section and anticipates the issues around user access control and trusted folders.

This is the seventh major version of Total Access Detective. Prior versions have included the following enhancements:

Version 12 for Access 2007 and ACCDB Databases

Total Access Detective 2007, version 12, runs in Microsoft Access 2007 and compares all database formats supported by Access 2007 including MDBs, ADPs, and the new ACCDB database format.

New Microsoft Access 2007 Properties

Access 2007 introduced many new features which are now compared.

Improved Two ADP Comparison

To compare properties of ADP objects that do not exist in MDB/ACCDB objects, a different startup database is used. Instead of running the TADETECT.ACCDB database, run the TADETECT.ADP file.

Two Table Comparison in ADPs

Tables in ADPs can be compared structurally including extended properties and indexes. Data can also be compared with combined results created in a new table.

New Table Data Comparison Options

Previously, data was only compared if the two tables had identical field definitions. There are now several new data comparison options:

  • Compare fields by order regardless of field names

  • Compare identical field names regardless of order

  • Treat the first field of non-keyed tables as unique

  • Ignore small differences between numbers (you set the level)

For more information on the Data Comparison Options, see page 32.

Data Comparison Results

When viewing the results of Data Comparison, the caption for the row column is # rather than ID, to avoid confusion if ID is a field in the tables being compared.

Table Comparison with Field by Field Results

Previously, during data comparison, modified records were only displayed as individual records listing the modified fields in one record. This is now supplemented with an additional table listing each field difference as a separate record showing the two values.

Query Data Comparison

Data from two queries can now be compared with an option to specify whether to perform a sequential search or use the first field as a key field.

Case Insensitive Module Comparison

For module comparisons, a new Ignore Case option is available to avoid flagging differences due to mismatched capital and lower case letters. This option is also available for the Text Comparison feature.

Support for Password Protected Databases

Objects in password protected databases are compared.

Report Enhancements

  • In addition to Preview, in Access 2007, reports can be opened in Report View so you can interactively filter and search the data.

  • Reports can be exported to Adobe PDF and XPS formats

  • Multiple reports can be exported to files in a folder and format you specify (e.g. PDF, XPS, HTML, snapshot, etc.)

  • A single report selection screen is used to select the reports for print, preview, report view, and export.

New Reports for Two Database Comparison

Many new reports were added:

  • Data Differences Fields Compared: shows the fields compared when an option other than identical structures is used

  • Table Data Comparison Paired Fields: shows paired field values

  • Portrait and Landscape reports for object comparison with better support for long object names and property values

  • When viewing object differences, reports are available for the entire list or just the currently filtered list

  • When viewing macro or module differences, reports are available for the entire list or just the current macro/module.

  • List of available reports with their description and default file name when you export it

Several reports were enhanced including:

  • Data Differences Summary now shows the total number of records, in addition to the new and modified number of records

New Reports for Two Object Comparison

  • Portrait and Landscape reports are available to show object property differences. The reports are improved to better show long object names and property values

  • Fields Compared for Data Differences: shows the fields compared when an option other than identical structures is used

  • Field Differences of Modified Records: shows paired field values

General Comparison Enhancements

Screen flashing is eliminated when comparing forms, reports, and modules. This lets you minimize Total Access Detective while it’s processing.

Two Object Comparison Enhancements

Separate Table Object and Data Comparison

When comparing two tables, you can compare either the table design or data, or both. Previously, the design was always compared.

Last Documentation is Available

The last comparison of two objects can be viewed under a new Last Analysis button. Similarly, the last selected object names are preserved when you run Total Access Detective again.

Partial Comparison Results

If you cancel while the objects are being compared, the process stops and the incomplete results displayed. This can be particularly helpful when comparing records and you decide to stop after it identifies a few differences and you don’t need all the differences.

Two Database Comparison Enhancements

Reduced Need to Prepare Databases

Previously, the Total Access Detective Prepare step was necessary before comparing modules between two databases. This is no longer needed when comparing MDB/ACCDB databases. Prepare is still required for ADPs.

Finish Button Eliminates Manual Selections

The Database Comparison wizard has a Finish button on all its pages. Simply select the two databases and press Finish to compare all the identically names objects. It skips the Wizard pages for the options, and uses the previously specified values.

Command Line Support

To eliminate manually selecting the database and options, a Windows shortcut can pass the names of the two databases to compare, which automatically selects all the common objects and compares them.

Text Comparison Feature Added

The text comparison feature which was previously only available under the two object comparison feature, is now available on the two database comparison side as well.

Improved User Interface

  • With Access 2007, the user interface is enhanced to support new features such as maximized tabbed views, transparent buttons with graphics, filtered datasheet views, navigation bar captions, colors, fonts, etc.

  • Two object comparison now shows the object and other differences (data or modules) as separate tabs

Vista and User Security Support

  • Total Access Detective is compatible with Vista and the new User Access Control features.

  • Temporary files are placed in your user folder rather than the Total Access Detective folder

  • The Help file is in the new CHM format rather than HLP format.

Version 9.7, 10.7, and 11.7 Updates

In conjunction with the release of Version 12.0 for Access 2007, updates were released to offer similar features for Access 2000 (version 9.7), 2002 (version 10.7), and 2003 (version 11.7)

Version 11 for Access 2003

Version 11 for Access 2003 includes many new features including:

  • Ability to combine data differences from two tables into a new table.

  • Comparison of Access Data Projects

  • Export of database comparison results to another database

  • Relationship comparison

  • Several additional reports, including:

    • Database Comparison Summary

    • Objects with Differences

    • Data Differences Summary

    • Identical Objects in Both Databases

Version 9.5 and 10.5 for Access 2000 and 2002

In conjunction with the enhancements added to version 11 for Access 2003, updates were released to offer similar features for Access 2002 (version 10.5) and Access 2000 (version 9.5).

Version 10 for Access 2002

Version 10 supported Access 2002. It added simplified selection of modified objects, data differences options for memo fields, and more accurate comparison of numeric fields.

Version 9 for Access 2000

Version 9 was created for Access 2000. It added the Text Comparison feature and support for Data Access Pages.

Version 8 for Access 97

Version 8 was created for Access 97.

Version 2 for Access 2.0

The first version was created for Access 2.0.

See Also

  • Product Highlights

  • What Total Access Detective Detects

  • Enhancements in This Version

  • Visit Our Web Site


Visit Our Web Site

FMS is constantly developing new and better developer solutions. Total Access Detective is part of our complete line of products designed specifically for the Access developer. Please take a moment to visit us online at fmsinc.com to find out about new products and updates.

Product Updates

FMS is committed to quality software. When we find problems in our products, we fix them and post the new builds on our web site. Check our Product Updates page in the Technical Support area for the latest build, or see Using the Update Wizard for information on how to check for the availability of updates.

Product Announcements and Press Releases

Read the latest information on new products, new versions, and future products. Press releases are available the same day they are sent to the press. Sign up in our Feedback section to have press releases automatically sent to you via email.

Product Descriptions and Demos

Detailed descriptions for all of our products are available. Each product has its own page with information about features and capabilities. Demo versions for most of our products are also available.

Technical Papers and Tips

FMS personnel often speak at conferences and write magazine articles, papers, and books. Copies and portions of this information are available to you online. Learn about our latest ideas and tricks for developing more effectively.

Social Media

Connect with us, share your experiences, learn from others, and ask your questions in our virtual community.

  • Like our Facebook page

  • Visit our blog

  • Follow us on X/Twitter

  • Visit our technical support forums

Links to Other Development Sites

Jump to other locations, including forums, user groups, and other sites with news, techniques, and related services.

See Also

  • Product Highlights

  • What Total Access Detective Detects

  • Enhancements in This Version

  • Enhancements from Previous Versions


Installation and Startup

Total Access Detective comes with an automated setup program to get you up and running as quickly as possible. This section describes the system requirements, installation steps, instructions for upgrading from previous versions, and instructions for uninstalling. It also provides instructions for international users, and tips for troubleshooting startup errors.

See Also

  • System Requirements

  • Upgrading from Previous Versions

  • Installing Total Access Detective

  • Using the Update Wizard

  • Uninstalling Total Access Detective

  • Running Total Access Detective

  • Instructions for International Users

  • Startup Errors


System Requirements

Total Access Detective is a Microsoft Access library database that runs within Access. Its system requirements are similar to the requirements of Microsoft Access, and include:

  • A copy of the Microsoft Access version corresponding to the Total Access Detective version.

  • Hardware and operating system supported by Microsoft Access.

  • 60 MB free disk space to install the product, and additional disk space to store your documentation.

Total Access Detective can only be opened through its associated version of Access, and only works with database formats supported by the specific version of Access.

See Also

  • Installing Total Access Detective

  • Using the Update Wizard

  • Uninstalling Total Access Detective

  • Running Total Access Detective


Installing Total Access Detective

Upgrading from Previous Versions

Just as multiple versions of Access can reside on the same machine, multiple versions of Total Access Detective can exist on the same machine provided that they are installed in separate directories.

Note that only one version from Access/Office 2016 onwards can be installed on a machine, so Total Access Detective also follows this requirement. If you have Total Access Detective 2016 installed, when you install Total Access Detective 2025, the 2016 will no longer be available.

Each version of Total Access Detective is a completely separate program and does not share any files with other versions. If you are no longer using any previous versions of Microsoft Access, you can remove the older version of Total Access Detective from your machine. See Uninstalling Total Access Detective for details.

Installation Instructions

Total Access Detective is installed using an automated setup program. To install Total Access Detective, follow these steps:

  1. Locate and run the setup program.

  2. Enter your registration information and product key (serial number).

  3. Choose to install it for your machine or just for you; Installing it for the machine allows other users of your PC to run Total Access Detective.

  4. Specify the destination folder for the files.

  5. Be sure to read the readme file for any late breaking news.

Where to Install Total Access Detective

For best performance, install Total Access Detective on a local hard drive. Installing to a network drive may cause slower performance.

Total Access Detective is an Access add-in which needs to modify itself to link to different tables, databases, etc. Be sure to install it to a folder where you have read/write permissions.

Do NOT install it in the C:\Program Files folder which Windows User Access Control (UAC) normally sets to READONLY after installation.

See Also

  • System Requirements

  • Using the Update Wizard

  • Uninstalling Total Access Detective

  • Running Total Access Detective


Using the Update Wizard

Total Access Detective includes a built-in mechanism to check the availability of updates via the Internet. If you have an active Internet connection, you can use the Total Access Detective Update Wizard to ensure that you have the latest version.

From the About form, click the Check Updates button.

You can also launch it from the Windows Start menu under Total Access Detective, Update Wizard. Follow the prompts on the form to check for the latest update.

See Also

  • System Requirements

  • Installing Total Access Detective

  • Uninstalling Total Access Detective


Uninstalling Total Access Detective

Total Access Detective follows standard Windows installation protocol, so uninstalling is straightforward. From the Windows Start Menu, select:

  1. Add or Remove Programs

  2. Select Total Access Detective from the list of installed programs

  3. Click Uninstall and follow the prompts.

For Windows 7 or earlier, use the Control Panel, then open Programs and Features to uninstall.

If you prepared databases with Total Access Detective, a *.DDB, *.DDE, or *.DDA file is created for each database. This file is stored in the same folder as your database. Use the Windows Search feature to locate these files, and remove them if desired.

See Also

  • System Requirements

  • Installing Total Access Detective


Running Total Access Detective

Total Access Detective runs from within Microsoft Access. If you are familiar with Microsoft Access, you will be very comfortable using Total Access Detective.

Total Access Detective performs comparison in two modes:

  • Two objects within one database (described in Comparing Two Objects in One Database)
    Open your database and select Total Access Detective from the Database Tools ribbon Add-ins menu.

  • Objects between two databases (described in Comparing Objects in Two Databases):
    Launch Total Access Detective Database Compare from the Windows Start menu then select the two databases to compare.

Comparing Databases on a Network

Total Access Detective allows you to compare databases residing on a network drive, but we recommend documenting local copies of these databases for two reasons:

  1. When you compare a database, you don't want other users opening or changing objects. Total Access Detective cannot compare objects that are opened or locked by others.

  2. Performance over a network is substantially slower than a local drive. Total Access Detective is a disk-intensive program—it may need to open objects in design view and read properties and/or compare data records. Because of this, running across a network connection may cause slower performance and may affect other users on the network.

Comparing Password-Protected Databases

When comparing two objects in the same database, Total Access Detective can compare all object types, regardless of whether the database is protected by a password.

When comparing two databases, simply provide the password for each and all their objects can be compared.

Comparing Databases with Workgroup Security

Total Access Detective can run database comparison on databases with Workgroup security provided that:

  1. Both databases use the same workgroup security file (*.MDW).

  2. The user group has open/run permissions for the database (not necessary for specific objects, just needed at the database level).

  3. The databases are not set to "Read Only".

Follow these steps to compare two secured databases:

  1. Start Access with your Workgroup Security settings.

  2. Open TADetect.accdb (or TADetect.mdb version 2003 or earlier), which is located in Total Access Detective’s installation folder.

Comparing Access Data Projects

Total Access Detective can compare native Access objects in Access Data Projects (ADPs and ADEs), including: forms, reports, pages, macros, modules, and command bars. It cannot, however, compare objects that exist in SQL Server, such as tables, views, and diagrams. When comparing ADPs, you must run the Total Access Detective Prepare process on each ADP.

ADPs were deprecated by Access 2013, so this is only available in the Access 2010 and earlier versions. To compare two Access Data Projects (ADPs), select Total Access Detective ADP Compare from the Windows Start menu.

See Also

  • System Requirements

  • Instructions for International Users

  • Startup Errors


International Users

Total Access Detective automatically detects international versions of Access and adjusts its behavior accordingly. The program’s documentation, forms, and help file are in English, but the property values it detects are displayed in your Access version’s local language.

Printing Reports on A4 Paper

By default, the reports in Total Access Detective are set for US Letter size; however, you can use A4 paper instead. This option is accessible from any report dialog box:

Reports Dialog Box with A4 Paper Option

See Also

  • System Requirements

  • Running Total Access Detective

  • Startup Errors


Startup Errors

Most errors with Total Access Detective occur when you first start it. This section explains the most common startup errors and offers suggestions on how to fix them.

Microsoft Access cannot find Wizard, or there is a syntax error in the Declarations section of a Visual Basic module

Microsoft Access uses the registry to store information about add-ins. The setup program places several entries in the Windows Registry to identify the location and name of the Total Access Detective library database, and the name of the main Total Access Detective function. If these registry entries are incorrect, or if the Total Access Detective installation is corrupt, this error message appears.

Re-install Total Access Detective to resolve this problem.

The current database is not updateable

You have opened the current database in read-only mode, or another condition has forced the database to be read-only. Total Access Detective cannot analyze a database opened in read-only mode. Close the database, open it in normal mode, and restart Total Access Detective.

Please close any forms or reports that are open and re-start Total Access Detective

You must close all forms, reports, and modules in your database before running Total Access Detective. Open forms, reports, and modules interfere with the operation of Total Access Detective. Close all windows except the database window and restart Total Access Detective.

This copy of Total Access Detective is in use

Total Access Detective can be installed on a network drive but can only be accessed by one user at a time. If more than one user attempts to start Total Access Detective at the same time, the second user sees a dialog box saying the copy of Total Access Detective is already in use.

This message also appears if you attempt to run Total Access Detective in two instances of Access on the same workstation. Click [OK] to return to Microsoft Access and try again later.

Total Access Detective exclusively locks the database to ensure that only one user is accessing it at one time. If Microsoft Access exits abnormally while Total Access Detective is running, an LDB lock file may be left in place, and may erroneously report that Total Access Detective is in use. If this happens, you should manually delete the lock file by following these steps:

  1. Ensure that no other users are running Total Access Detective. This step is very important. If you manually delete the lock file while a user is running Total Access Detective, you may cause that user’s system to crash.

  2. Close all instances of Microsoft Access on your workstation.

  3. From Windows Explorer, locate the folder where Total Access Detective is installed. Locate and delete the lock file (TAD_C.LDB).

  4. Restart Microsoft Access, and run Total Access Detective again.

If these troubleshooting suggestions do not resolve your issue, or if you encounter a different error, please contact technical support for additional assistance.

See Also

  • System Requirements

  • Installing Total Access Detective

  • Using the Update Wizard

  • Running Total Access Detective

  • Comparing Databases on a Network

  • Comparing Access Data Projects

  • Comparing Password-Protected Databases

  • Comparing Databases with Workgroup Security

  • Instructions for International Users


Comparing Two Objects in One Database

Total Access Detective’s Object Comparison feature finds all differences between any two objects in one database. This section explains how to use the Object Comparison feature to quickly see the differences in properties, fields, controls, macro lines, module lines, import export specifications, command bars, and data.

See Also

  • Starting the Object Comparison Wizard

  • Selecting Objects for Comparison

  • Comparison Options

  • Property Comparison Results

  • Data Comparison Results

  • Macro and Module Comparison Results

  • Viewing Last Analysis

  • Text Comparison


Starting the Object Comparison Wizard

Open the database containing the objects to compare, and launch Total Access Detective from the Add-ins menu.

Microsoft Access 365/2024-2016 Add-ins Menu for Launching Total Access Detective

The Total Access Detective Prepare menu item is for Database Comparisons.

Object Comparison Wizard

When you select Total Access Detective from the Add-ins menu, the Comparison Wizard appears:

Launch Database Comparison from the Add-in

If you are looking to compare two databases, the Database Comparison program is normally launched from a shortcut on the Windows Start menu while the add-in is designed to compare objects in your database. If you intended to compare differences between two databases, click the [Compare Databases] button

New Compare Database button on the Total Access Detective Add-in form

The [Compare Databases] button launches the Database Comparison program and closes the add-in. It does not close your database.

Selecting Objects for Comparison

Select the object type from the drop down list box.

Then, specify the names of the two objects to compare, set comparison options, and click [Run].

Permissions

In order to compare objects, Total Access Detective needs to open them in design mode. For Total Access Detective to do this, you must have Read Design permission on the objects you are comparing.

Comparison Options

Depending on the object type that you select, different Comparison Options are available.

  • Table and Query Comparison Options

  • Data Comparison Options

  • Form and Report Comparison Options

  • Module and Macros/Text Comparison Options

  • Property Selection

Comparison Results

  • Property Comparison Results

  • Data Comparison Results

  • Macro and Module Comparison Results

  • Viewing Last Analysis

  • Text Comparison


Comparison Options

Depending on the object type that you select, different Comparison Options may be available.

Topics

  • Table and Query Comparison Options

  • Data Comparison Options

  • Form and Report Comparison Options

  • Text Comparison Options

See Also

  • Starting the Object Comparison Wizard

  • Selecting Objects for Comparison

  • Property Selection

  • Property Comparison Results

  • Data Comparison Results

  • Macro and Module Comparison Results

  • Viewing Last Analysis

  • Text Comparison


Table and Query Comparison Options

When comparing tables and queries, you can compare the objects (fields, indexes, and properties), table data, or both:

Data comparison only occurs if the two objects have the same fields. This can take significant time if there are many records. For faster performance, compare databases on your desktop rather than across a network.

Data Comparison

Data Comparison identifies records that are new, deleted, or modified. When viewing the results, you can also combine the data from the two data sources into a new table.

In addition to comparing data with identical fields, tables with similar structures, different field names, and different field order can be compared. Options also customize the way results are displayed. An overview of the selected options shows on the main screen:

Topics

  • Data Comparison Options

  • Record Identifier Tab

  • Field Comparison Tab

  • Documentation Tab

  • Display Tab

  • Numerical Accuracy Tab

See Also

  • Starting the Object Comparison Wizard

  • Selecting Objects for Comparison

  • Comparison Options

  • Property Comparison Results

  • Data Comparison Results


Data Comparison Options

When comparing data between tables or queries, several options are available to let you control how the comparisons are made and the results:

  • Record Identifier

  • Field Comparison

  • Documentation

  • Display

  • Numerical Accuracy

See Also

  • Starting the Object Comparison Wizard

  • Selecting Objects for Comparison

  • Comparison Options

  • Property Comparison Results

  • Data Comparison Results

  • Macro and Module Comparison Results

  • Viewing Last Analysis

  • Text Comparison


Record Identifier

Data Comparison Options

Click the [Data Options] button to open the Data Comparison Options form.

When comparing data between tables or queries, several options are available to let you control how the comparisons are made and the results.

Record Identifier Tab

The Record Identifier tab of the Data Comparison Options form displays options for comparing queries and tables that do not have a primary key:

Data Comparison Options, Record Identifier

For tables with a primary key, the key fields are used to match up rows for comparison, and the options on this tab do not apply.

For tables without a primary key or queries, you can compare the rows sequentially, or specify that the first field in is the “identifier” (uniquely identifies the row). For example, if you’re comparing these two queries:

ID | First | Last
1 | Nancy | Davolio
2 | Andrew | Fuller
3 | Janet | Leverling

ID | First | Last
1 | Nancy | Davolio
3 | Janet | Leverling
2 | Andy | Fuller

Comparing the fields sequentially reports that the second record is completely different—none of the fields match. Total Access Detective does not continue comparing data after the first difference is found.

Designating the first field as unique, on the other hand, reports the difference in ID 2: “Andrew” does not match “Andy.” Since a unique identifier is found, Total Access Detective continues comparing the rest of the data in the table.

See Also

  • Data Comparison Options

  • Field Comparison Tab

  • Documentation Tab

  • Display Tab

  • Numerical Accuracy Tab


Field Comparison

Data Comparison Options - Field Comparison Tab

The Field Comparison tab of the Data Comparison Options form includes options for how the fields are compared:

Data Comparison Options, Field Comparison

  • All Field Names and Types Match: Tables or queries have the same field names and structure (column count and data types).

  • Field Order: Table structures match, but field names differ between the two tables or queries.

  • Identical Field Names Only: Field names and data types match, but column count and/or order is different. Choosing this option compares Identically named fields, and skips fields that are not in both tables.

Note that only fields with the same data types can be compared, i.e. a Text field cannot be compared to a Number field.

See Also

  • Data Comparison Options

  • Record Identifier Tab

  • Documentation Tab

  • Display Tab

  • Numerical Accuracy Tab


Documentation

Data Comparison Options - Documentation Tab

The Documentation tab of the Data Comparison Options form specifies what to display when differences are detected between records. Decide whether to show all differences for a record, or to limit the differences that are shown:

Data Comparison Options, Documentation

Limit the Amount of Differences to Document

By default, all the differences between two records are shown listing the values of every field that differs. This can be quite extensive, especially if you have large text or memo fields.

You can limit what’s documented with the “First 255 Characters” option. This truncates the record difference to the first 255 characters. This is useful, if you simply want to know a record was modified regardless of every field modification.

Limit Memo Fields Differences

For large memo fields, the results can be very large when different memo field values are documented. Choose whether to show all differences up to 3K, show only the first 255 characters, or to only show that a difference exists (for example, 1: Memo 2: Memo).

See Also

  • Data Comparison Options

  • Record Identifier Tab

  • Field Comparison Tab

  • Display Tab

  • Numerical Accuracy Tab


Display

Data Comparison Options - Display Tab

The Display tab of the Data Comparison Options form controls how data differences are displayed in the Data Comparison Results:

Data Comparison Options, Display

Compressed Display

Select Compressed to save space and show each field’s difference on one line. This compact format shows the field values side-by-side.

In this example, differences are found for two fields named FirstName and ZipCode, and the values for the two tables (1 and 2):

[FirstName] 1:John 2:Jon
[ZipCode] 1:22182 2:22102

Expanded Display

However, this can be difficult to see the actual difference, especially with large text or numbers. With the Expanded option, each field value is on a separate line. With the pair of field values stacked, it’s easier to see differences:

[FirstName]
1:John
2:Jon
[ZipCode]
1:22182
2:22102

See Also

  • Data Comparison Options

  • Record Identifier Tab

  • Field Comparison Tab

  • Documentation Tab

  • Numerical Accuracy Tab


Numerical Accuracy

Data Comparison Options - Numerical Accuracy Tab

The Numerical Accuracy tab includes options for comparing numbers:

Data Comparison Options, Numerical Accuracy

By default, any difference between numbers is considered a difference that’s documented.

However, due to rounding and floating point issues, numbers with decimals may be very close but not identical. Flagging these differences may not be helpful, or you may not care about such tiny differences.

This option allows you to set an acceptable difference, based on the ratio of the difference to the field values. Select an acceptable difference between 0% (fields must match exactly) and 10% (numbers can be up to 10% different, and still considered identical).

The % difference is calculated by dividing the difference in the two values by their average.

See Also

  • Data Comparison Options

  • Record Identifier Tab

  • Field Comparison Tab

  • Documentation Tab

  • Display Tab


Form and Report Comparison Options

When comparing forms and reports, choose to compare the objects (controls, sections, and properties), the modules behind the objects, or both.

If you compare Modules, there are additional module comparison options to select the number of identical lines needed to resynchronize, and whether differences in blank lines, capitalization, comments or indentations should be considered changes.

Comparing Embedded Macros

Embedded Macros were introduced with Microsoft Access 2007. They can be added as events at the form or report level or for individual controls. Total Access Detective has a macro parser that compares the differences between embedded macros to identify differences at the command by command level. Rather than simply reporting that two embedded macros are different, Total Access Detective can identify changes in arguments and comments, adding or deleting commands, etc.

Embedded macro comparisons also respect your selection of Module Comparison options such as ignoring comments.

See Also

  • Comparison Wizard

  • Selecting Objects for Comparison

  • Comparison Options

  • Property Comparison Results

  • Data Comparison Results

  • Macro and Module Comparison Results

  • Viewing Last Analysis

  • Text Comparison


Module Comparison Options

Module and Macro Text Comparison Options

The [Text Options] button lets you specify several settings for customizing how modules and macros are compared.

There are two parts. After a different line is found, the number of identical lines after it that define a new block of code differences. Then the types of text to ignore:

Module Comparison Options

# of Lines to Resync

Total Access Detective compares module procedures on a line-by-line basis, and determines whether differences are due to modified or new lines. If it detects new lines, Total Access Detective shows the new lines from one module plus the line where the code is resynchronized between the two modules. The lines that follow in both modules are not considered different even though they are on different lines.

Total Access Detective defines this resynchronization based on a repetition of identical lines in both modules. By default, this value is 3 lines. That is, when three identical lines are encountered in both modules, the prior lines’ differences are documented and the code is resynchronized.

You can increase or decrease this setting if the resynchronization is incorrect. If the value is too low, small amounts of code within an added group cause resynchronization. If the value is too high, groups do not get resynchronized. We recommend using the default value; we have found 3 lines to work well.

Module Code to Ignore

There are four options for ignoring module code that may be slightly different:

  • Blank Lines

  • Case

  • Comments

  • Indentations

  • Line Numbers

Ignore Blank Lines

This option lets you ignore differences due to blank lines. If a procedure has more or less blank lines than another, they are not considered different.

Ignore Case

This lets you ignore differences due to capital and lower case letters. This is especially useful if you have code where the case of procedure or variable definitions is modified. Without this option, references to all those procedures or variables are flagged as differences.

However, with this option selected, case differences that you may want to find (e.g. messages displayed to the user) would be ignored.

Ignore Comments

This is a powerful option that lets you ignore differences in comments. The VBA code parser identifies comments on their own lines, multiple lines, or the end of lines and ignores any differences between procedures due to comments. The only differences will be changes to the actual VBA code.

Ignore Indentations

This avoids flagging lines where the text is identical but the indentation is not. Checking this option ignores differences due to spaces or tabs at the beginning of a line of code.

This option is particularly important if new control blocks are added. For instance, you may have added an IF…END IF statement around existing code and indented the block. With this option on, only the IF and END IF lines are considered different. With the option off, every line in the block is flagged as different because of the indentation.

Regardless of this setting, all blank lines at the beginning or end of a module or procedure are ignored.

Ignore Line Numbers

This option lets you ignore the line numbers in the VBA code. Developers often add line numbers so error handling can pinpoint the line where a crash occurs. Our Total Visual CodeTools product lets you do that easily.

However, when comparing modules, one may have line numbers and the other not, or the line numbers may be different even though the VBA code that’s numbered hasn’t changed. With this option, the line numbers can be ignored in the comparison so that only the difference with the actual VBA code is shown.

Results

See Module Differences for information about viewing the results.

See Also

  • Comparison Wizard

  • Selecting Objects for Comparison

  • Comparison Options

  • Property Comparison Results

  • Data Comparison Results

  • Macro and Module Comparison Results

  • Viewing Last Analysis

  • Text Comparison


Property Selection

By default, all Access properties that could indicate differences are compared. The Property Selection button on the Main Menu lets you reduce this by unselecting properties you may not care about.

For instance, you may not care about the DateCreated property for the objects. By removing this, you eliminate flagging objects that are different solely based on this property.

Property Selection Screen

The properties are organized by Object Type. Unselect the properties you don’t want to compare. Press the Select All button to reset the selections.

Click OK to return to the Main Menu.

See Also

  • Starting the Object Comparison Wizard

  • Selecting Objects for Comparison

  • Comparison Options

  • Property Comparison Results

  • Data Comparison Results

  • Macro and Module Comparison Results

  • Viewing Last Analysis

  • Text Comparison


Property Comparison Results

When you click [Run] on the Comparison Wizard, Total Access Detective compares the two objects and finds their differences.

If property comparison were conducted on the objects, their differences are shown on the first tab. The list of properties that are compared can be reduced from the [Property Selection] button.

Each difference is displayed as a separate record. The list shows the item and property name, along with the property values for Object 1 and Object 2. Each object contains many items (fields, controls, etc.), each with many properties. If an item exists in one object and not the other, it is listed as “.Not Defined” in the object’s column where it does not exist. For identically named items, each property is compared and those with different values are shown.

Property Comparison Results

When there are many differences, it’s hard to find the important ones. Depending on the object type, a check box is available to reduce the list to just the most important items to quickly see major differences rather than trivial property settings.

Filter Table Differences to Just Fields in One Table But Not the Other

  • Tables: Fields and Indexes in one table and not the other:

  • Queries: Fields and Parameters in one query and not the other:

  • Forms: Controls and Sections in one query and not the other:

  • Reports: Controls, Groups and Sections in one query and not the other:

These buttons are available on the Results form for Object differences:

Button | Description
Report | Select reports to print, preview, report view, and export.
Export | Export results into a table in your database.
Close | Return to the first screen (select objects).
Exit | Close Total Access Detective.

See Also

  • Object Comparison Reports

  • Exporting Object Comparison Results

  • Comparison Wizard

  • Comparison Options

  • Data Comparison Results

  • Macro and Module Comparison Results

  • Viewing Last Analysis

  • Text Comparison


Report

Object Comparison Report Menu

The [Report] button opens a dialog with a list of available reports for your current view:

Select Reports Dialog

These options are available:

Button | Description
Preview | Preview the current report your cursor is on (it does not need to be selected).
View | Open the current report in Report View.
Print | Send the selected (checked) reports to the printer.
Export | Export the selected (checked) reports to a variety of formats in the folder you specify.

For the current report (the current report record), you can Preview it or put it into Report View.

For printing or exporting, select the reports you want by checking them, and press [Print] to send them to your default printer, or [Export] to send them to a destination and format you specify.

See List of Reports for a full list of the available reports.

See Also

  • Property Comparison Results

  • Exporting Object Comparison Results

  • Data Comparison Results

  • Macro and Module Comparison Results

  • Viewing Last Analysis


ExportReports

Report Export

You can select one or more reports to export to files by clicking the [Export] button:

Export Reports to File

Specify the type of output and destination folder. The export formats include Adobe PDF, HTML, Snapshot, Text, rich text, and XPS. PDF and XPS formats are not available in Microsoft Access 2003 or earlier. Snapshot is not available in Access 2010 or later.

Click [OK] to generate the files. Each report has a default file name. If any of the files already exists, you are prompted to confirm overwriting them.

See Also

  • Object Comparison Report Menu

  • Database Comparison Reports


Exporting Data

Export Data

Unlike the Export button when selecting reports, the [Export] button while viewing the results lets you to save the results to a table in your database:

Export Results to a Table in Your Database

See Also

  • Property Comparison Results

  • Object Comparison Reports

  • Text Comparison

  • Macro and Module Comparison Results

  • Data Comparison Results

  • Comparison Wizard


Data Comparison Results

If you choose to compare data between your tables or queries and they have the same fields, data comparison results are show on the Data and Modified Fields tabs:

Table Results View Options

Topics

  • Data Records Tab

  • Modified Fields Tab

  • Result Options

  • Combining Data Between Two Tables

See Also

  • Comparison Wizard

  • Data Comparison Options

  • Property Comparison Results

  • Macro and Module Comparison Results

  • Viewing Last Analysis

  • Text Comparison


Data Tab

Data Comparison Results

If you choose to compare data between your tables or queries, and the object have the same fields, the data comparison results are show on the Data Records and Modified Fields tabs:

Table Results View Options

Data Records Tab

The Data Records tab shows all the data differences:

Data Differences for each Record

The following types of records are flagged:

  • Records in table/query 1 but not table/query 2 (based on key fields)

  • Records in table/query 2 but not table/query 1 (based on key fields)

  • Modified records (identical key field values) with the fields with different values listed

  • For unkeyed tables/queries, the first record that differs (further analysis cannot be performed)

The results include the following information:

Fields | Description
Key Field(s) | The key field or fields that identify the record
Diff Type | The difference type (see below)
Differences | Description that the record is in one but not the other, or for modified records, values for each field difference
Num Diffs | The number of fields with different values
Diff Fields | The names of the fields that differ

The [Diff Type] field identifies how the record differs:

Diff Type | Description
1 | The record exists in table/query 1 but not table/query 2.
2 | The record exists in table/query 2 but not table/query 1.
M | The record exists in both tables/queries and is modified.
N | Differences exist (for comparisons without a primary key).

Use the "Filter" drop down at the top of the form to limit the list by difference type:

For modified records, each field difference is shown with the field name in brackets ([ ]) and the values for table/query 1 and 2 listed after the number (“1:” or “2:”). If multiple fields are different, each difference is on a separate line.

To see more than the first two lines, expand the record’s height or move to the field and press [Shift]+[F2] to zoom:

Zoom to See Contents of the Field

How the data differences are generated and displayed depend on the data comparison options you selected. For instance, if you selected the option to show only the first 255 characters, the text in the Differences column is truncated after 255 characters.

See Also

  • Property Comparison Results

  • Data Comparison Results

  • Modified Fields Tab

  • Result Options

  • Combining Data Between Two Tables

  • Macro and Module Comparison Results


Modified Fields Tab

Data Comparison Results - Modified Fields Tab

The Modified Fields tab shows the field by field difference for modified records. Each table's field value is in its own field to make it easier to copy.

Table Data Differences, Modified Records

This does not show new or deleted records (records in one table but not the other).

See Also

  • Property Comparison Results

  • Data Comparison Results

  • Data Tab

  • Result Options

  • Combining Data Between Two Tables

  • Macro and Module Comparison Results


Result Options

Data Comparison Results Options

The following options are available at the bottom of the form:

Button | Description
Report | Reports to print, preview, view and export.
Export | Export results into a table in your database.
Combine | Combine the data from the tables that you compared into a new table.
Close | Return to the first screen (select objects).
Exit | Close Total Access Detective.

See Also

  • Property Comparison Results

  • Data Comparison Results

  • Data Records Tab

  • Modified Fields Tab

  • Combining Data Between Two Tables

  • Macro and Module Comparison Results


Combining Data Between Two Tables

One of the most useful features of Total Access Detective is combining data between two data sources into a new table.

Click the [Combine] button when viewing the data differences to display the Combine Data form:

Combine Table Data Form

Since it is not possible to determine modified records, data from tables and queries without a unique identifier cannot be combined.

These options are available:

Table Name

Specify the name of the table to create in the current database.

Create New Table From

Select the table to use for the combined table. If both tables’ properties are identical, it doesn’t matter which one you choose, but if they are different, you may prefer one over the other.

The rest of the options determine which records are included in the combined table:

Include All Identical Records

Select this option to include the identical records between the two compared tables.

Include Records from Table 1 Not in Table 2

Select this option to include records that are in Table 1, but not in Table 2.

Include Records from Table 2 Not in Table 1

Select this option to include records that are in Table 2, but not in Table 1.

Include Modified Records From

Select this option to include records that exist in both tables, but are modified. Then, specify which table’s modified records you want in the combined table.

Use Caution If Data Changed Since Comparison

Total Access Detective does not store a copy of the data it compared, just the differences. When it combines the data from the two tables, it’s using the current data in those sources to populate the new table and apply the modifications it found. If your data changed since the comparison, the results may not be what you expect. To avoid problems, run the data comparison again if your data was modified.

See Also

  • Property Comparison Results

  • Data Comparison Results

  • Data Records Tab

  • Modified Fields Tab

  • Result Options

  • Macro and Module Comparison Results


Macro and Module Comparison Results

Unlike other comparisons that list different property values, macro and module comparisons (including code behind forms and reports) show different lines of macro definitions or module code.

Module Procedures are Compared by Name

A module is composed of procedures and properties (the General Declarations section is treated as the first procedure). Total Access Detective understands VBA syntax and compares each procedure or property to its corresponding name in the other module. This means that their sort order does not matter, which makes Total Access Detective much more powerful than a simple text comparison program.

Macros are Compared by Sub-Macro Name

Most macros only contain one set of lines that run from start to finish. However, they may contain multiple sub-macros if macro names are assigned. Total Access Detective compares macros similar to the way it compares modules. Again, sort order doesn't matter—identically named macro names (sub-macros) are compared to each other, and those that exist in one, but not the other are flagged.

Object Match then Line-by-Line Comparisons

For identically named procedures and macros, Total Access Detective conducts a line-by-line comparison. When lines differ, the different lines in both objects are shown. If a resync occurs before the end of the procedure, the last line of each block is shown so you can see they are identical. This technique clearly reveals new, modified, and deleted lines of code.

For procedures with completely different code (an inability to resync), it tells you they are completely different rather than listing every line.

Module Comparison Results

For every difference, the procedure name is listed followed by each version of it in each module. Differences in the sort order of the procedures are not documented, since the order is not important.

The Identical Procedures tab lists all the procedures that had no differences.

List of Identical Procedures in both Forms

See Also

  • Module Comparison Options

  • Macro and Module Comparison Reports

  • Embedded Macro Differences

  • Comparison Wizard

  • Property Comparison Results

  • Data Comparison Results

  • Viewing Last Analysis

  • Text Comparison


Embedded Macros

Embedded Macro Differences

For embedded macros on forms and reports, the differences are shown on the Embedded Macros tab:

Differences between Embedded Macros

They are listed by Item (control name or blank for the form/report level), event name, and the differences. The original complete embedded macro values in the two objects are displayed under Version1 and Version2. Reports are also available for Embedded Macro differences.

See Also

  • Module Comparison Options

  • Property Comparison Results

  • Data Comparison Results

  • Macro and Module Comparison Results

  • Macro and Module Comparison Reports

  • Viewing Last Analysis


Macro and Module Comparison Reports

Three sets of reports are available for module differences. Click [Report] to access these reports.

Macro and Module Differences Report

List of differences at the object level (procedure or sub-macro) and line-by-line level for identically named objects. See Macro Differences, Module Differences

Source Code Reports

A listing of the source code for the entire macro or module. This includes line numbers (which restart for each submacro or procedure), and makes it easy to identify lines referenced in the Differences report.

Identical Procedures Report

The list of procedures with no differences is available. This list is not generated if the two modules are identical.

See Also

  • Module Comparison Options

  • Property Comparison Results

  • Data Comparison Results

  • Macro and Module Comparison Results

  • Embedded Macro Differences

  • Viewing Last Analysis

  • Text Comparison


Viewing Last Analysis

The Last Analysis button retrieves your most recent results after you close or exit the comparison wizard:

Last Analysis Button

This button is only enabled if your current database is the same as the database where the last analysis was run. Additionally, if your objects were modified since the last analysis, the results will not be current

See Also

  • Comparison Wizard

  • Property Comparison Results

  • Data Comparison Results

  • Macro and Module Comparison Results

  • Text Comparison


Text Comparison

Total Access Detective offers a module (text) comparison feature that does not require your code to be in an existing module. Simply type, paste, or retrieve the text from a file. Press the [Compare Text] button at the bottom of the main form:

Compare Text Button

Text Comparison Button

The text can be compared as regular blocks of text, or as VBA code, which performs procedure/property comparisons (similar to module comparison).

Entering Text Blocks for Comparison

Click [Compare Text] on the main form to launch the text comparison form:

Text Comparison Form

There are sections for the two blocks of text to compare.

  1. You can select the text from a file using the […] button. It automatically puts the file name in the Name section and the text contents below it.

    1. Use the Refresh button [image] to update the text from the file.

    2. The [Refresh All] button [image] updates both text blocks with their current file text.

  2. You can paste the text into the form and give it a name. By default, the names are Block 1 and 2, so use a better name to make the comparison results more understandable.

Clear Text

To clear the text for a block, click the Trash can button [image] next to it.

To reset the both names and text blocks, click the [Clear All] button

Topics

  • Text Comparison Options

  • Text Comparison Results

See Also

  • Comparison Wizard

  • Property Comparison Results

  • Data Comparison Results

  • Macro and Module Comparison Results

  • Viewing Last Analysis


Text Comparison Options

At the bottom of the form, there are options to specify how the text should be compared

Treat as VBA Code

When you select the Treat as Code option, Total Access Detective analyzes your text as if it is module or class code. This is similar to the analysis performed on modules in your database—it breaks your text into its parts (declarations, procedures, and properties) and compares it to the corresponding sections in the other text block. Identically named objects are compared (regardless of where they are located in each text block), and any lines that don’t match are reported as differences. If there is not a corresponding procedure or property, the results simply show that the procedure or property exists in one but not the other.

If you check this option and your text is not code, Total Access Detective treats your entire text block as if it were the general declarations section of a module. If you are not comparing code, uncheck this option to perform a simple text comparison.

Text Options

The Text Options button lets you specify how to compare the text. These options are identical to the Module Comparison options. The items selected to ignore are displayed next to the button.

See Also

  • Text Comparison

  • Text Comparison Results

  • Text Comparison Warning


Text Comparison Results

Press [Run] to perform the analysis and the results are displayed:

Text Comparison Results: Differences Tab

The results are similar to macro and module comparison results. Print the results by clicking [Report], or use the [Export] button to export them.

The Identical Procedures tab displays the list of procedure names that did not have any differences. This makes it easy to confirm that no changes occurred in those procedures:

Text Comparison Results: Identical Procedures Tab

Text Comparison Results: Identical Procedures Tab

In addition to the Text Block Differences, see the list of procedures with differences:

Text Comparison Results: Procedures with Differences Tab

Text Comparison Results: Procedures with Differences Tab

See Also

  • Text Comparison

  • Text Comparison Options


Comparing Objects in Two Databases

This section explains Total Access Detective’s Database Comparison feature, which compares objects between two databases. The results show unmatched objects, modified objects, and differences in objects with identical names. Table relationships, data, security permissions, database properties, and library references can also be compared.

See Also

  • Database Comparison Overview

  • Database Preparation

  • Database Comparison Wizard

  • Generating Database Comparison

  • Page 1: Specify Databases to Compare

  • Page 2: Review and Select Objects

  • Page 3: Specify Comparison Options

  • Page 4: Database Verification

  • Comparisons Completed

  • Viewing Results and Printing Reports

  • Viewing Object Differences

  • Viewing Data Differences

  • Viewing Macro Differences

  • Viewing Module Differences

  • Unmatched Objects

  • Errors

  • Reports

  • Compare Two Blocks of Text


Database Comparison Overview

The Database Comparison wizard guides you through selecting the databases and objects to compare.

Preparing Your Database

If you want to compare certain object types in an Access database (command bars or library references), you must complete a preparation step before running the wizard (see Database Preparation for details).

Starting the Database Comparison

If you prepared your database, or if you do not want to compare the objects listed above, open the TADETECT.ACCDB database.

This database is located in the folder where you installed Total Access Detective, and the Setup program creates a shortcut to the database in the Windows Start menu.

Using the Database Comparison Wizard

When the Wizard opens, follow these steps to compare the databases:

  1. Specify the two databases to compare

  2. Review the list of unmatched objects (objects that exist in one database but not the other)

  3. Select the identically named objects for detailed analysis

  4. Specify the comparison options

  5. Generate the comparison and view/print the results

See Also

  • Database Preparation

  • Database Comparison Wizard

  • Generating Database Comparison

  • Viewing Results and Printing Reports

  • Compare Two Blocks of Text


Database Preparation

Database preparation is not necessary if you are just comparing tables, queries, forms, reports, macros, and modules between your Access ACCDB/MDB databases. It is necessary to compare certain objects like command bars and library references

Database preparation is required because Microsoft Access does not allow certain objects to be examined without having the database itself open. Because Database Comparison doesn't open either database, it cannot see these properties. When you prepare your database, Total Access Detective creates a separate database that contains these objects, and that database is used during analysis.

Launch the Database Prepare Add-in

To prepare your databases for comparison, open each database is Microsoft Access. Then from each database, run Total Access Detective Prepare.

Select Total Access Detective Prepare from the Database Tools ribbon, Add-ins menu

Microsoft Access 365/2024-2016 Add-ins Menu for Launching Total Access Detective

This screen appears:

Confirm Database Preparation

Click [OK] to proceed, and a database is created in the same folder and name as your database with an extension of .DDB or .DDE for your databases with extensions *.ACCDB/*.MDB and *.ACCDE/*.MDE respectively. This database contains information necessary for Total Access Detective to compare these objects.

Once you prepare a database, you do not need to repeat this process unless you modified or added a command bar or VBA library reference.

If you no longer need the preparation files, you can safely delete them to reclaim disk space.

See Also

  • Database Comparison Wizard

  • Generating Database Comparison

  • Viewing Results and Printing Reports

  • Compare Two Blocks of Text


Database Comparison Wizard

To compare databases, open TADetect.ACCDB from the folder where you installed the program, or use the shortcut in the Windows start menu under:

Total Access Detective 2026, Database Compare

This can also be found from the Windows Search bar by searching "Detective":

Windows 11 Search for "Detective"

Total Access Startup

Total Access Detective is launched with the correct version of Microsoft Access even if you have multiple Access versions installed on your machine. This is handled by our Total Access Startup program.

Main Form

When the database opens, the main form appears:

Database Comparison Wizard Main Form

The main form has the following buttons:

Button | Description
Generate New Comparison | Launch the Database Comparison wizard
View, Filter, and Print | View the results of the databases compared, and print reports. You can also open previously compared results.
Compare Two Blocks of Text | Compare any two blocks of text

See Also

  • Database Preparation

  • Database Comparison Wizard

  • Generating Database Comparison

  • Viewing Results and Printing Reports

  • Compare Two Blocks of Text


Generating Database Comparison

To compare two databases, click [Generate New Comparison Between Two Databases]

The wizard guides you through the process of generating the comparison:

  1. Specify the two databases to compare

  2. Review the list of identically named objects, and the list objects found in only one of the databases

  3. Select the identically named objects to compare

  4. Specify the comparison options

  5. Start the object comparison

When you click [Finish], Total Access Detective examines the databases and generates the results. You can then see the database differences by selecting [View, Filter, and Print Comparison Results] from the main form.

See Also

  • Page 1: Specify Databases to Compare

  • Page 2: Review and Select Objects

  • Page 3: Specify Comparison Options

  • Page 4: Database Verification

  • Page 5: Storage Database

  • Comparisons Completed

  • Database Comparison Overview

  • Database Preparation

  • Database Comparison Wizard

  • Viewing Results and Printing Reports

  • Compare Two Blocks of Text


Database Comparison Wizard Page 1 - Specify Databases to Compare

Database Comparison Wizard Page 1 — Select Databases to Compare

From the main form, click [Generate New Comparison Between Two Databases] to start the comparison.

The first page of the Wizard appears:

Select the Two Databases to Compare

Use the […] buttons to locate the databases to compare, and click [Next] to proceed. If you press [Finish], all identically named objects in the two databases are compared using your last specified options.

See Also

  • Generating Database Comparison

  • Page 2: Review and Select Objects

  • Page 3: Specify Comparison Options

  • Page 4: Database Verification

  • Page 5: Storage Database

  • Comparisons Completed


Database Comparison Wizard Page 2 - Review the Identically

Database Comparison Wizard Page 2 — Review and Select Identically Named Objects

Total Access Detective performs a quick analysis and displays all the identically named objects in the two databases:

Select Objects for Comparison

Use the icons on the left side to filter the list by object type. The Status column can help you determine which objects to select for comparison:

Status | Description
<none> | Objects have the same dates (most likely identical).
? | Two tables have identical dates, but their data may differ. For tables, modification dates are based on structural changes, not data entry.
! | Objects are not the same. Last Modified dates do not match.

Selecting Objects for Comparison

To select an object for analysis, use its corresponding check box. The [Select All] button selects all objects in the current filter, and the [Select Diffs] button selects all objects with different last modification dates (objects with the ! symbol in the status column).

Keep in mind that the last modified date does not change when data changes are made. If you want to compare table data, be sure to flag all tables with the ? symbol in the status column.

Note: For ADPs, only Access objects (forms, reports, macros, modules, command bars, and library references) can be compared.

Printing the List of Identically Named Objects

The list of identically named objects gives a quick overview of the databases— use the [Report] button for a report of these objects:

Print Objects in Both Databases

Unmatched Objects

Click the [Unmatched Objects] button for a list of objects that exist in one database, but not the other:

Unmatched Objects

This list shows you all objects that were added or deleted from either database. Review this list for a quick overview of the different objects in the databases, or use the [Report] button to generate a report.

See Unmatched Objects for details.

See Also

  • Generating Database Comparison

  • Page 1: Specify Databases to Compare

  • Page 3: Specify Comparison Options

  • Page 4: Database Verification

  • Page 5: Storage Database

  • Comparisons Completed


Database Comparison Wizard Page 3 - Specify Comparison Options

Database Comparison Wizard Page 3 — Specify Comparison Options

A variety of comparison options are available for the selected objects:

Database Comparison Options

Compare Table Data

When comparing tables, you can optionally compare data. Note that only data in local tables can be compared—linked tables cannot be compared. If you need to compare linked tables, either import the tables or use the Object Comparison feature described in the previous section. Because tables cannot be compared between ADPs, data comparison is not available for ADPs.

Data comparison can take a significant amount of time for tables with many records. Compare local copies of your databases to reduce the documentation time.

Additional data comparison options are available from the Data Options button:

These options are identical to the data options for Object Comparison and are explained in Data Comparison Options.

Compare Field Properties

Select this option to compare table and query field properties. Retrieving field properties for linked tables is relatively slow. If you have many linked tables, consider using the database that contains these tables in your documentation, or unselect this option if you are not interested in field properties. See Field Comparison

Compare References

Select this option to compare VBA (library) references between the two databases. To compare references, your databases must be prepared.

Compare Permissions

Select this option to compare security (permissions) settings.

Microsoft Access does not allow you to access the permissions of objects unless you have sufficient security rights. The best way to avoid problems with permissions comparisons is to log into Microsoft Access as a member of the Admin group before starting Total Access Detective.

Compare Form and Report Modules

Select these options to compare the code behind the selected forms and reports. If you are only interested in layout information, you can speed up processing by turning these options off. See Form and Report Comparison Options

Module and Macro Options

You can specify the # of Lines to Resync and the types of code to ignore to adjust how Total Access Detective finds differences in modules and macros. These are identical to the Module and Macro / Text Options under Object Comparison.

See Also

  • Generating Database Comparison

  • Page 1: Specify Databases to Compare

  • Page 2: Review and Select Objects

  • Page 4: Database Verification

  • Page 5: Storage Database

  • Comparisons Completed


Database Comparison Wizard Page 4 - Database Verification

Database Comparison Wizard Page 4 — Database Verification

If you select command bars or references for comparison, Total Access Detective checks if the database was properly prepared. Page 4 displays the preparation status:

Database Preparation Status

If you've properly prepared both databases, the indicators on this page display “Yes.” If either database is not prepared, one or more of the indicators display “No,” and a message appears at the bottom of the page. If this occurs, you should prepare the problem database, and restart the Database Comparison wizard.

If you have no data access pages, command bars, or references selected, one or more of the indicators on this page will display “None Selected.”

If everything is okay, click [Next].

See Also

  • Generating Database Comparison

  • Page 1: Specify Databases to Compare

  • Page 2: Review and Select Objects

  • Page 3: Specify Comparison Options

  • Page 5: Storage Database

  • Comparisons Completed


Database Comparison Wizard Page 5 - Storage Database

Database Comparison Wizard Page 5 — Storage Database

By default, Total Access Detective stores the database comparison results in a database called TAD_DB.TDA in your application data folder (it’s just an Access MDB file with a TDA extension).

You can change this from this screen:

Specify Database Storage Name

If the file already exists, information on the databases and when it was compared is displayed.

If you specified a file in a different folder, the [Make this the Default Storage Folder] button is enabled to let you set that as your new default folder for your output databases.

When you’re ready, press [Finish] to start the analysis.

See Also

  • Generating Database Comparison

  • Page 1: Specify Databases to Compare

  • Page 2: Review and Select Objects

  • Page 3: Specify Comparison Options

  • Page 4: Database Verification

  • Comparisons Completed


Database Comparison Wizard Comparisons Completed

While Total Access Detective is comparing the databases, it displays the current progress and the objects being compared. The processing time depends on the number of objects selected and their complexity.

When the comparison finishes, Total Access Detective displays the number of differences, the number of errors found, and the elapsed time for the comparison process:

Comparison Completed

Click [OK] to return to the main menu, and use the [View, Filter, and Print Comparison Results] button to see the results.

See Also

  • Generating Database Comparison

  • Page 1: Specify Databases to Compare

  • Page 2: Review and Select Objects

  • Page 3: Specify Comparison Options

  • Page 4: Database Verification

  • Page 5: Storage Database


Viewing Results and Printing Database Comparison Reports

From the main form, select the [View, Filter, and Print Comparison Results] button to examine the results of the Database Comparison.

Database Comparison Results Menu

Database Comparison Results Menu

The top of the form shows the database name where the comparisons are stored, the names of the two databases that were compared, and when the comparison occurred.

If you saved the results in different database names, you can load it with the browse [...] button:

Buttons are enabled or disabled based on the results of the comparison.

Results Overview

Summary of differences by object type for properties and code

Unmatched Objects
Objects that exist in one database but not the other.

Errors
Comparison errors, including objects that could not be compared.

Object Differences
Property differences for all objects (tables, relationships, forms, etc.)

Macro Differences
Macro differences and Macro source code.

Module Differences
Module differences and source code, including form and report modules.

Data Differences
Table data differences.

Reports
Results reports for previewing and printing.

See Also

  • Database Comparison Overview

  • Database Preparation

  • Database Comparison Wizard

  • Generating Database Comparison

  • Compare Two Blocks of Text


Results Overview

View a summary of all the differences between the objects compared between the databases.

Two tabs are available to see the number of differences by Object Type and Object Name.

Summary by Object Type Tab

Comparison Overview, Object Type Tab

For each object type see:

  • Number of total items for the object type

  • Number in one database and not the other

  • Number of identically named object

  • Number selected for comparison and of those, the number that have differences

  • For the differences that were found, the number of property and code differences

  • Number of objects with errors that prevented them from being compared

Summary by Object Tab

For each object name, see the number of property differences and code differences, if any.

Comparison Overview, Object Tab

See Also

  • Viewing Results and Printing Reports

  • Unmatched Objects

  • Database Comparison Errors

  • Object Differences

  • Macro Differences

  • Module Differences

  • Data Differences

  • Reports


Database Comparison Unmatched Objects

Total Access Detective lists objects (tables, queries, forms, data access pages, reports, macros, modules, command bars, relations, references) in one database but not the other.

Use this form as a quick way to discover new or deleted objects.

Unmatched Objects

See Also

  • Viewing Results and Printing Reports

  • Results Overview

  • Database Comparison Errors

  • Object Differences

  • Macro Differences

  • Module Differences

  • Data Differences

  • Reports


Database Comparison Errors

Total Access Detective may be unable to compare certain objects.

For instance, data comparison on tables with different structures, corrupt objects, and queries based on missing tables cannot be compared. These objects and errors (or warnings) are listed on the Errors form.

Comparison Errors

See Also

  • Viewing Results and Printing Reports

  • Results Overview

  • Unmatched Objects

  • Object Differences

  • Macro Differences

  • Module Differences

  • Data Differences

  • Reports


Database Comparison Object Differences

Differences in property values for identically named objects are listed under [Object Differences].

If an item exists in one object and not the other, it is listed as Unmatched, but its properties are not listed.

Object Tab

Object Differences, Object Tab

Filtering the List

Since the list of object differences can be large, a filter is available to limit the list by object type, name, and property. The object type and optional name filter makes it easy to select a specific object type, then by name.

Filter by Object Type and/or Name

When filtered by object type, the Object tab displays a check box to filter the list for major differences:

  • Tables: Fields and Indexes in one table and not the other:

  • Queries: Fields and Parameters in one query and not the other:

  • Forms: Controls and Sections in one query and not the other:

  • Reports: Controls, Groups and Sections in one query and not the other:

For more detailed filtering by object and property, select the Advanced option and click the […] button.

Embedded Macros tab

If there are differences between embedded macros on forms and reports, an additional Embedded Macros tab is available

Embedded Macro Differences between Forms and Reports

While viewing the results, these options are available:

Button | Description
Report | Select reports of the results to preview, print, view or export
Export | Export the results into a table in the database that you specify

See Also

  • Advanced Filtering by Object and Property

  • Viewing Results and Printing Reports

  • Results Overview

  • Unmatched Objects

  • Database Comparison Errors

  • Macro Differences

  • Module Differences

  • Data Differences

  • Reports


Advanced Filtering by Object and Property

Since the list of object differences can be quite large, a filter is available to limit the list by object type and property. Select the Advanced option and click the […] button:

The Objects tab lists the objects included in the comparison:

Object and Property Filter, Objects Tab

The Properties tab lists the properties where differences were found between the two databases:

Object and Property Filter, Properties Tab

Use the icon menu on the left to filter the object or property list, and the [Select All] and [Clear All] buttons to help you select the desired items.

After selecting the objects and properties to include in the filter, click [OK] to return to the results form with the filter applied.

Filters Also Apply to Export and Reports

The filter that you select is respected when you export and print the results. For example, if you filter the list to show only differences in the Customers table, and then export the results, only the differences for that table are exported. If you filter the list to show only the RowSource property, and then print the report, only RowSource differences are printed.

See Also

  • Viewing Results and Printing Reports

  • Results Overview

  • Unmatched Objects

  • Database Comparison Errors

  • Macro Differences

  • Module Differences

  • Data Differences

  • Reports


Database Comparison Macro Differences

Macro Differences

Total Access Detective performs line-by-line comparisons for the selected macros, and displays code differences (including modified lines and blocks of added or deleted code).

Each macro may have sub-macros (macro names) within it— Total Access Detective reports differences in sub-macros as well

Note: Total Access Detective does not document differences in the sort order of macro names, since sort order doesn’t affect the macro’s behavior.

Macro Differences

These buttons are available:

Button | Description
Report | Reports for the differences and source code for each macro. Reports are available for the currently viewed macro or all the macros with differences.
Export | Export the results into a table in the database you specify

See Also

  • Viewing Results and Printing Reports

  • Results Overview

  • Unmatched Objects

  • Database Comparison Errors

  • Object Differences

  • Module Differences

  • Data Differences

  • Reports


Database Comparison Module Differences

Module Differences

Total Access Detective performs line-by-line comparisons for the selected modules. If you selected the option to compare form and report modules, the code behind the selected forms and reports is also compared.

Total Access Detective does not document differences in the sort order of procedures since sort order doesn’t affect the VBA code’s behavior.

There are three tabs:

  • Module Differences: Differences between the lines of code for identically named procedures and properties, as well as a list of unmatched procedures and properties. This includes modified lines and blocks of added or deleted code.

  • Identical Procedures: List of all procedures with no differences

  • Procedures with Differences: List of procedures with differences.

Module Differences and Identical Procedures

These buttons are available:

Button | Description
Report | Reports for the differences and source code of each module. Reports are available for the currently viewed module or all the modules with differences.
Export | Export the results into a table in the database you specify

See Also

  • Module Comparison Options

  • Viewing Results and Printing Reports

  • Results Overview

  • Unmatched Objects

  • Database Comparison Errors

  • Object Differences

  • Macro Differences

  • Data Differences

  • Reports


Database Comparison Data Differences

Data Differences

If you selected the option to compare table data, Total Access Detective compares the data in the two databases based on the Data Comparison options specified.

If the tables have the same key fields, the data differences results show all missing and modified records (modified records have identical key values but differences in other fields).

If the table is not keyed and you did not choose the option to treat the first field as the key field, Total Access Detective cannot determine which records are new, deleted, or modified. It compares the tables in their default sort order and reports the first record that is different.

Each table’s comparison is available by selecting the table from the drop down list of table names. Only tables with data differences are listed.

Data Tab

The Data tab shows all data differences, including modified rows and rows in one table but not the other:

Data Differences, Data Tab

Modified Fields Tab

The Modified Fields tab displays rows that exist in both tables, but are different:

Data Differences, Modified Fields Tab

While viewing the results, these options are available:

Button | Description
Report | Select a report to print, preview, report view, or export
Export | Export the results to a table in a database you specify
Combine | Combine the data from the tables into a new table

The results include these fields:

Fields | Description
Differences | The field values which differ. This can be quite large. Expand the height of the record or use the zoom feature ([Shift]+[F2]) to view the whole field.
Num Diffs | Number of fields with different values
Diff Type | Difference type (see below)
Diff Fields | Names of the fields that differ
Key Field(s) | Key field(s) that identify the record

The “Diff Type” field identifies how the record differs—use this field to identify differences quickly:

Diff Type | Description
1 | Record exists in table 1 but not table 2
2 | Record exists in table 2 but not table 1
M | Record exists in both tables and is modified
N | Differences exist for tables without a primary key

See Also

  • Data Comparison Options

  • Combining Results

  • Viewing Results and Printing Reports

  • Results Overview

  • Unmatched Objects

  • Database Comparison Errors

  • Object Differences

  • Macro Differences

  • Module Differences

  • Reports


Combining Results

Combine Tables

When viewing table data differences, Total Access Detective allows combining the data into a new table. This powerful feature is available by clicking the [Combine] button to open this form:

Combine Table Data Form

Browse for a database to create the combined table in, and select a name for the table.

The remaining options are similar to Combining Data Between Two Tables in Object Comparison.

See Also

  • Data Comparison Options

  • Viewing Results and Printing Reports

  • Results Overview

  • Unmatched Objects

  • Database Comparison Errors

  • Object Differences

  • Macro Differences

  • Module Differences

  • Reports


Database Comparison Reports

The Reports feature allows you to print several reports simultaneously, rather than from each of their respective sections.

See the List of Reports for a full list of the available reports. This form lets you select the reports:

Report Selection Form

The following options are available on the Reports form:

Button | Description
Preview | Preview the current report your cursor is on (it does not need to be selected).
View | Open the current report in Report View which supports ad hoc filtering.
Print | Send the selected (checked) reports to the default printer
Export | Export the selected (checked) reports to a variety of formats in a folder you specify.

Note that the reports here do not have filtering. They include all the objects and properties or code for its category. If you only want a subset, view the data from the other forms and print it from there. You can also use the [View] button to open reports in Report View, and use the built-in Access options to apply filtering.

See Also

  • Database Comparison Report List

  • Viewing Results and Printing Reports

  • Results Overview

  • Unmatched Objects

  • Database Comparison Errors

  • Object Differences

  • Macro Differences

  • Module Differences

  • Data Differences


Compare Two Blocks of Text

From the main form, select [Compare Two Blocks of Text] to compare text.

The functionality is identical to the Text Comparison feature available under Object Compare.

See Also

  • Database Comparison Overview

  • Database Preparation

  • Database Comparison Wizard

  • Generating Database Comparison

  • Viewing Results and Printing Reports


Additional Topics

This section contains additional information about the Total Access Detective files and functionality. You do not need to read this section to use Total Access Detective, however it provides a deeper understanding of how the program works.

See Also

  • How Total Access Detective Works

  • Comparing Two Databases from a Command Line

  • Special Date Comparison Issues


How Total Access Detective Works

Architecture

Total Access Detective is written completely in Microsoft Access using VBA. It works in two distinct modes:

  • Two Object Comparison
    Launched as an Access add-in while you’re in the database with the objects to compare

  • Two Database Comparison
    Launched as an Access database to point to your two databases

In both cases, Total Access Detective compares your objects without modifying them.

For two object comparison, the objects are placed into design mode, compared, and closed without saving any changes. For two database comparisons, objects are imported into our database and opened for comparison without affecting the source object.

Temporary Files

Total Access Detective stores its results as temporary files in your Windows Application Data folder:

C:\Users\<UserName>\AppData\Roaming\FMS\Total Access Detective\26.0

The location of your Application Data folder depends on your Windows user settings.

By default, Object Comparison stores its results in an Access database (extension *.TDA) in your Windows Application Data folder.

See Also

  • Comparing Two Databases from a Command Line

  • Special Date Comparison Issues


Comparing Two Databases from a Command Line

There may be situations where you want to compare the same two databases repeatedly. You can create a Windows shortcut to point to your two databases to launch Total Access Detective and have it automatically compare all the common objects between your two databases using the settings from the last session and store the results in a database you specify.

Here’s an example:

"C:\Program Files\Microsoft Office\Office16\MSACCESS.EXE"

"C:\Total Access Detective 2026\tadetect.accdb"

/cmd "C:\Northwind1.accdb;C:\Northwind2.accdb; C:\Output\NorthwindCompare.tda"

Shortcut Syntax

There are three parts to the command line. The first two are for Access to open the Total Access Detective database for comparing the two databases:

1. Microsoft Access path

The first part is the full path to the Microsoft Access program (MSACCESS.EXE)

2. Total Access Detective database path.

The second part is the full path to the Total Access Detective database comparison file: TADETECT.ACCDB.

3. Command Line Parameter

The third part is the command /cmd parameter with quotes around the full path to the two databases separated by a semicolon.

You can optionally add a third database name which is the database that stores the results. If you don’t include it, the default Total Access Detective database name is used, but that is overwritten the next time it runs. If you are comparing multiple pairs of databases, you’ll want to specify the output database name uniquely for each pair so you can view them later.

You can name the storage database with any extension but we recommend using the *.TDA extension for consistency with other Total Access Detective storage files.

Only One Comparison at a Time

You can only run one instance of Total Access Detective at a time. You can run Total Access Detective with the command line consecutively but not simultaneously

See Also

  • How Total Access Detective Works

  • Special Date Comparison Issues

  • Database Comparison Wizard


Special Date Comparison Issues

Total Access Detective uses Visual Basic for Applications (VBA) code to retrieve and store property values, and stores them in an Access table. If the property value is a date (for example, the DateModified property), Total Access Detective reads the value as a date. Since it stores all differences internally as string values, it stores dates according to the current Windows settings for date handling.

This means that Total Access Detective’s date comparison results may not display the full four digits year. If Total Access Detective shows a date property difference, you should use Access to view the actual property values to determine the differences.

Use the Windows Control Panel Regional Settings to view and change your date settings. Refer to your Windows help file for more information about regional settings.

See Also

  • How Total Access Detective Works

  • Comparing Two Databases from a Command Line


Product Support

These topics provides information about troubleshooting problems that arise and obtaining support for Total Access Detective.

  • Support Resources

  • Technical Support Options


Technical Support Resources

Support Resources

There are many resources available to help you resolve issues you may encounter. Please check the following:

Readme File

Check the README file for the latest product information. The README file is located in the folder where you installed the product.

Product Documentation

We’ve spent a great deal of care and time to make sure the Total Access Detective manual and help file are very detailed. Check the Table of Contents and Index for your question, and read the appropriate pages.

See Also

  • Web Site Support

  • Technical Support Options

  • Contacting Technical Support


Web Site Support

The FMS web site contains extensive resources to help you use our products better. Resources include product updates, frequently asked questions (FAQs), forums, information on new versions, betas, and other resources.

Web Site

The FMS web site is located at:

fmsinc.com

News and important announcements are posted here.

Support Site

The main support page is located at:

https://support.fmsinc.com

From this page, you can quickly locate the other support resources.

Product Updates

FMS takes product quality very seriously. When bugs are reported and we can fix them, we make the updates available on our web site. If you are encountering problems with our product, make sure you are using the latest version.

Product updates can also be checked using the update wizard. See Using the Update Wizard for details.

Frequently Asked Questions (FAQs)

Common questions and additional information beyond what is in the manual is often available from our FAQs.

Microsoft Patches

Our support site also includes links to Microsoft patches that are related to our products. Make sure you’re using the latest versions by checking here or visiting the Microsoft site.

See Also

  • Support Resources

  • Technical Support Options

  • Contacting Technical Support


Technical Support Options

FMS is committed to providing professional support for all of our products. We offer free access to our online FAQs and forums. Bug reports, feature requests, suggestions, and general pre-sales questions related to our products are always available at no cost.

Additional maintenance plans are available to provide subscribers with enhanced technical support. This is the best way for you to stay current with the rapidly changing technologies that impact project development, and to ensure you are getting the maximum return from your software investment. Please visit our web site, fmsinc.com, for the most up-to-date information.

Features & Benefits

Premium

Incident

Standard

Access to FAQs

Access to Forums

Minor Upgrades/Bug Fixes

Telephone Support

Per incident

First 30 Days

Email Support

Per incident

First 30 Days

Priority Response Time 1

Senior Engineer Support Team

Email Project for Testing

Programmatic Code Assistance 2

Major Upgrades for Current Version (not between Access versions)

Additional fee

Additional fee

Cost

Annual Fee

Fee Per Incident

Included

1. Response generally within two business days. Actual resolution may take longer depending on complexity of the issue reported.

2. Custom Programming implementation is not provided in our Support Maintenance plans. For products that include a programmatic interface, we can provide instructions for using our programmatic interface, and show examples, but we do not implement this into your projects. This service is available from our Professional Solutions Group.

Premium Subscription

The Premium Subscription is the ideal option for customers seeking the highest level of support from FMS. The annual fee entitles you to telephone and email technical support from a senior support engineer.

From time to time, FMS may release new versions of existing products which add new features. These are point releases (e.g. from version 26.0 to 26.1) and are different from new builds that correct problems in existing features (e.g. from version 26.00.0001 to 26.00.0002).

These point releases are available for a nominal upgrade fee to existing customers. Premium Technical Support subscribers receive these upgrades automatically and for no additional charge during their subscription term.

NOTE: Upgrades between versions (for instance going from Access 2013 to Access 2016) are not considered Point Release Upgrades and are not included in the Premium Subscription.

Subscriptions are available for a twelve month period, and may be purchased at any time. You must be the registered owner of the product to purchase a subscription and the only person contacting FMS for support under the subscription.

Please ensure you have purchased the Subscription you need for Total Access Detective.

Per Incident

Our Per Incident package is available individually or by purchasing multiple incidents in advance. The Per Incident support package provides telephone and email technical support from a Senior Technical Support Engineer for resolving one incident.

An incident is defined as a single question related to one of our products. The Per Incident period is from start to finish (report of the incident to resolution) for a single incident. If you anticipate multiple questions for a single product, we recommend purchasing the Premium Subscription.

Standard Subscription

Our Standard Subscription comes with every product purchased for no additional cost. The standard subscription comes with access to our FAQs and forums, and responses to bug reports and feature requests for that version.

Please note that the person requesting support must also be the registered user of the product. Registration is required and will be requested by our Technical Support professionals.

See Also

  • Support Resources

  • Web Site Support

  • Contacting Technical Support


Contacting Technical Support

If the troubleshooting suggestions and other support resources fail to resolve your problem, please contact our technical support department. We are very interested in making sure you are satisfied with our product.

Registering Your Software

You must be registered to receive technical support. Registration also entitles you to free product updates, notifications, information about upcoming products, and beta invitations. You can even receive free email notification of our latest news. If you purchased your product directly from FMS, you are already registered. If not, Contact Us.

Contact Us

The best way to contact us is to submit a ticket on our support site:

https://support.fmsinc.com

Please provide detailed information about the problem that you are encountering. This should include the name and version of the product, your operating system, and the specific problem. If the product generated an error file, please submit that as well.

Our ticketing system will let you track the progress of your issue and see the entire thread of communications and file attachments.

Please bear in mind that a unique issue may involve meetings between the technical support staff and product developers, so your patience is appreciated.

Microsoft Technical Support

FMS only provides technical support for its products. If you have questions regarding Microsoft products, please contact Microsoft technical support.

See Also

  • Support Resources

  • Web Site Support

  • Technical Support Options


Report: Appendix

Sample Reports

This section provides samples of the reports available in Total Access Detective.

Object Comparison Reports

  • Object Property Differences

  • Fields Compared for Data Differences

  • Data Differences by Record

  • Field Differences of Modified Records

  • Macro Differences

  • Macro Lines

  • Module Differences

  • Module Printout

Database Comparison Reports

  • Summary of Database Differences

  • Objects in Both Databases

  • Objects Not in One Database

  • Selected Objects with Differences

  • Selected Objects that are Identical

  • Object Property Differences

  • Data Differences Summary

  • Data Differences Fields Compared

  • Data Differences

  • Macro Differences

  • Macro Lines

  • Module Differences

  • Module Printout

  • Comparison Errors

  • List of Reports


Report: Object Comparison

Object Comparison Reports

The Object Comparison feature includes several reports for viewing and printing the differences between two objects in a database.

See Also

  • List of Reports

  • Object Property Differences

  • Fields Compared for Data Differences

  • Data Differences by Record

  • Field Differences of Modified Records

  • Macro Differences

  • Macro Lines

  • Module Differences

  • Module Identical Procedures

  • Module Printout

  • Text Comparison Results


Report: Object Property Differences

Object Property Differences

This report shows the differences between the two selected objects. It can display differences between tables, fields, data access pages, queries, forms, reports, controls, command bars, permissions, and relationships.

Object Property Differences Report

See Also

  • Fields Compared for Data Differences

  • Data Differences by Record

  • Field Differences of Modified Records

  • Macro Differences

  • Macro Lines

  • Module Differences

  • Module Identical Procedures

  • Module Printout

  • Database Comparison Reports


Report: Fields Compared for Data Differences

Fields Compared for Data Differences

This report shows the fields that were matched for data comparison. The field names are identical between tables, unless comparison was performed by field order. The report displays the field name from each table, and whether it is a key field. For non-keyed tables or queries, if the option is selected to treat the first field as a unique identifier, that field is shown as a Key Field.

Fields Compared for Data Differences

See Also

  • Object Property Differences

  • Data Differences by Record

  • Field Differences of Modified Records

  • Macro Differences

  • Macro Lines

  • Module Differences

  • Module Identical Procedures

  • Module Printout

  • Database Comparison Reports


Report: Data Differences by Record

Data Differences by Record

This report shows the data differences between the selected tables. It displays the key fields for the new and modified records, along with the number of fields that differ, the field names, and the actual differences. See Data Comparison for more information.

Data Differences by Record Report

See Also

  • Object Property Differences

  • Fields Compared for Data Differences

  • Field Differences of Modified Records

  • Macro Differences

  • Macro Lines

  • Module Differences

  • Module Identical Procedures

  • Module Printout

  • Database Comparison Reports


Report: Field Differences of Modified Records

Field Differences of Modified Records

This report shows the data differences for modified records in the selected tables side by side. It displays the key fields, along with the number of fields that differ, the field names, and the actual differences. This report only shows records that were modified, not records that exist in one table and not in the other (records that were inserted or deleted).

Field Differences of Modified Records

See Also

  • Object Property Differences

  • Fields Compared for Data Differences

  • Data Differences by Record

  • Macro Differences

  • Macro Lines

  • Module Differences

  • Module Identical Procedures

  • Module Printout

  • Database Comparison Reports


Report: Macro Differences

Macro Differences

This report shows the differences between the selected macros.

Macro Differences Report

There are similar reports for Embedded Macro differences on forms and reports.

This report displays the blocks of code that are different. If your code is large and complex, use this report in conjunction with the Macro Lines report to determine the complete context of each block of code.

See Also

  • Object Property Differences

  • Fields Compared for Data Differences

  • Data Differences by Record

  • Field Differences of Modified Records

  • Macro Lines

  • Module Differences

  • Module Identical Procedures

  • Module Printout

  • Database Comparison Reports


Report: Macro Lines

Macro Lines

This report shows the complete source code for the selected macros. Along with the code, the report displays line numbers, which are reset to 1 at the beginning of each macro name. These line numbers are referenced in the Macro Differences report.

Macro Lines Report

There are similar reports for Embedded Macro differences on forms and reports.

See Also

  • Object Property Differences

  • Fields Compared for Data Differences

  • Data Differences by Record

  • Field Differences of Modified Records

  • Macro Differences

  • Module Differences

  • Module Identical Procedures

  • Module Printout

  • Database Comparison Reports


Report: Module Differences

Module Differences

This report shows the differences between the selected modules.

Module Differences Report

This report only displays the blocks of code that are different. If your code is large and complex, use this report in conjunction with the Module Source Code report to determine the complete context of each block of code.

See Also

  • Object Property Differences

  • Fields Compared for Data Differences

  • Data Differences by Record

  • Field Differences of Modified Records

  • Macro Differences

  • Macro Lines

  • Module Identical Procedures

  • Module Printout

  • Database Comparison Reports


Report: Identical Procedures

Module Identical Procedures

This report shows the list of procedures that are identical between the two modules. This makes it easy to confirm nothing changed in those procedures. Procedures are not listed if the entire module is identical.

Identical Procedures Report

See Also

  • Object Property Differences

  • Fields Compared for Data Differences

  • Data Differences by Record

  • Field Differences of Modified Records

  • Macro Differences

  • Macro Lines

  • Module Printout

  • Database Comparison Reports


Report: Module Printout

Module Printout

These reports show the complete source code for the selected modules. Along with the code, the report displays line numbers, which start at 1 for each procedure. These line numbers are referenced in the Module Differences reports.

Six reports are available:

  • Module Code from Database 1

  • Module Code from Database 2

  • Form Module Code from Database 1

  • Form Module Code from Database 2

  • Report Module Code from Database 1

  • Report Module Code from Database 2

Module Printout Report

See Also

  • Object Property Differences

  • Fields Compared for Data Differences

  • Data Differences by Record

  • Field Differences of Modified Records

  • Macro Differences

  • Macro Lines

  • Module Identical Procedures

  • Module Differences

  • Database Comparison Reports


Report: Database Comparisom

Database Comparison Reports

The Database Comparison feature includes several reports for viewing and printing the differences between two databases. View a list of all available reports by clicking the [Reports] button from the View Menu.

See Also

  • List of Reports

  • Summary of Database Differences

  • Objects in Both Databases

  • Objects Not in One Database

  • Selected Objects with Differences

  • Selected Objects that are Identical

  • Object Property Differences

  • Data Differences Summary

  • Data Differences Fields Compared

  • Data Differences

  • Macro Differences

  • Macro Lines

  • Module Differences

  • Module Identical Procedures

  • Module Printout

  • Comparison Errors

  • Compare Two Blocks of Text


Report: Summary of Database Differences

Summary of Database Differences

This report shows a summary of the database comparison:

Summary of Database Differences Report

See Also

  • Object Comparison Reports

  • Objects in Both Databases

  • Objects Not in One Database

  • Selected Objects with Differences

  • Selected Objects that are Identical

  • Object Property Differences

  • Data Differences Summary

  • Data Differences Fields Compared

  • Data Differences

  • Macro Differences

  • Macro Lines

  • Module Differences

  • Module Identical Procedures

  • Module Printout

  • Comparison Errors

  • List of Reports


Report: Objects in Both Databases

Objects in Both Databases

This report shows a list of objects that have identical names and object types in both databases, along with their modification dates and whether they were selected for comparison. This report is also available from page 2 of the Database Comparison wizard (see Printing the List of Identically Named Objects for details).

Objects in Both Databases Report

The Selected Objects report is similar and only shows the objects selected for comparison.

See Also

  • Object Comparison Reports

  • Summary of Database Differences

  • Objects Not in One Database

  • Selected Objects with Differences

  • Selected Objects that are Identical

  • Object Property Differences

  • Data Differences Summary

  • Data Differences Fields Compared

  • Data Differences

  • Macro Differences

  • Macro Lines

  • Module Differences

  • Module Identical Procedures

  • Module Printout

  • Comparison Errors

  • List of Reports


Report: Objects Not in One Database

Objects Not in One Database

Two reports show objects only in one of the two databases:

  • Objects in Database 1 Not in Database 2

  • Objects in Database 2 Not in Database 1

Use these reports to determine which objects were added or deleted.

Objects Not in One Database Report

See Also

  • Object Comparison Reports

  • Summary of Database Differences

  • Objects in Both Databases

  • Selected Objects with Differences

  • Selected Objects that are Identical

  • Object Property Differences

  • Data Differences Summary

  • Data Differences Fields Compared

  • Data Differences

  • Macro Differences

  • Macro Lines

  • Module Differences

  • Module Identical Procedures

  • Module Printout

  • Comparison Errors

  • List of Reports


Report: Selected Objects with Differences

Selected Objects with Differences

This report shows a list of objects that exist in both databases that have differences with the number of property and/or code differences in each, plus a summary by object type.

Selected Objects with Differences Report

See Also

  • Object Comparison Reports

  • Summary of Database Differences

  • Objects in Both Databases

  • Objects Not in One Database

  • Selected Objects that are Identical

  • Object Property Differences

  • Data Differences Summary

  • Data Differences Fields Compared

  • Data Differences

  • Macro Differences

  • Macro Lines

  • Module Differences

  • Module Identical Procedures

  • Module Printout

  • Comparison Errors

  • List of Reports


Report: Selected Objects that are Identical

Selected Objects that are Identical

This report shows objects selected for comparison that do not have differences.

Selected Objects that are Identical Report

See Also

  • Object Comparison Reports

  • Summary of Database Differences

  • Objects in Both Databases

  • Objects Not in One Database

  • Selected Objects with Differences

  • Object Property Differences

  • Data Differences Summary

  • Data Differences Fields Compared

  • Data Differences

  • Macro Differences

  • Macro Lines

  • Module Differences

  • Module Identical Procedures

  • Module Printout

  • Comparison Errors

  • List of Reports


Report: Object Property Differences between Databases

Object Property Differences

This report shows the property differences between the selected pairs of identically named objects in the two databases. It includes differences in tables, fields, queries, forms, reports, data access pages, controls, command bars, and permissions. This report does not include macro, module, or data differences.

There are two Object Property Differences reports with different layouts:

  • Object Property Differences (Portrait)

  • Object Property Differences (Landscape)

Object Property Differences Report

See Also

  • Object Comparison Reports

  • Summary of Database Differences

  • Objects in Both Databases

  • Objects Not in One Database

  • Selected Objects with Differences

  • Selected Objects that are Identical

  • Data Differences Summary

  • Data Differences Fields Compared

  • Data Differences

  • Macro Differences

  • Macro Lines

  • Module Differences

  • Module Identical Procedures

  • Module Printout

  • Comparison Errors

  • List of Reports


Report: Data Differences Summary

Data Differences Summary

This report shows a summary of the data differences between the selected tables. It displays the number of new records and modified records in each table. See Compare Table Data for details.

Data Differences Summary Report

See Also

  • Object Comparison Reports

  • Summary of Database Differences

  • Objects in Both Databases

  • Objects Not in One Database

  • Selected Objects with Differences

  • Selected Objects that are Identical

  • Object Property Differences

  • Data Differences Fields Compared

  • Data Differences

  • Macro Differences

  • Macro Lines

  • Module Differences

  • Module Identical Procedures

  • Module Printout

  • Comparison Errors

  • List of Reports


Report: Data Differences Fields Compared

Data Differences Fields Compared

By default, identical field names are compared. If you choose another data comparison option such as comparing fields based on field order or only comparing identically named tables, this report shows which fields were compared to each other. For non-keyed tables, if you choose to treat the first field as a unique identifier, it is shown as the Key Field.

Data Differences Fields Compared Report

See Also

  • Object Comparison Reports

  • Summary of Database Differences

  • Objects in Both Databases

  • Objects Not in One Database

  • Selected Objects with Differences

  • Selected Objects that are Identical

  • Object Property Differences

  • Data Differences Summary

  • Data Differences

  • Macro Differences

  • Macro Lines

  • Module Differences

  • Module Printout

  • Comparison Errors

  • List of Reports


Report: Data Differences

Data Differences

Several reports are available to show the data differences between the selected tables:

  • Data Differences (All)
    Shows all data differences between tables.

  • Data Differences (New in Database 1)
    Shows new records in database 1 for indexed tables.

  • Data Differences (New in Database 2)
    Shows new records in database 2 for indexed tables.

  • Data Differences (Modified Only)
    Shows modified records for indexed tables.

  • Data Differences (Non-Keyed Tables)
    Shows the first modified record for un-indexed (non-keyed) tables.

These reports display the key fields for the new and modified records, along with the number of fields that differ, the field names, and the actual differences. See Compare Table Data for details.

Data Differences (All) Report

See Also

  • Object Comparison Reports

  • Summary of Database Differences

  • Objects in Both Databases

  • Objects Not in One Database

  • Selected Objects with Differences

  • Selected Objects that are Identical

  • Object Property Differences

  • Data Differences Summary

  • Data Differences Fields Compared

  • Macro Differences

  • Macro Lines

  • Module Differences

  • Module Printout

  • Comparison Errors

  • List of Reports


Report: Macro Differences between Databases

Macro Differences

This report shows the differences between the selected macros.

Macro Differences Report

There are similar reports for Embedded Macro differences on forms and reports.

This report only displays the blocks of code that are different. If your code is large and complex, use this report in conjunction with the Macro Source Code report for the complete context of each block of code.

See Also

  • Object Comparison Reports

  • Summary of Database Differences

  • Objects in Both Databases

  • Objects Not in One Database

  • Selected Objects with Differences

  • Selected Objects that are Identical

  • Object Property Differences

  • Data Differences Summary

  • Data Differences Fields Compared

  • Data Differences

  • Macro Lines

  • Module Differences

  • Module Identical Procedures

  • Module Printout

  • Comparison Errors

  • List of Reports


Report: Macro Lines between Databases

Macro Lines

This report shows the complete source code for the selected macros. Along with the code, the report displays line numbers, which start at 1 for each macro name. These line numbers are referenced in the Macro Differences report. This report is available in these formats:

  • Macro Lines from Database 1

  • Macro Lines from Database 2

  • Macro Lines from Both Databases

The lines from the same macro from each database are printed one after the other. For short macros, both macros can appear on one page for visual comparison.

Macro Lines Report

There are similar reports for Embedded Macro differences on forms and reports

See Also

  • Object Comparison Reports

  • Summary of Database Differences

  • Objects in Both Databases

  • Objects Not in One Database

  • Selected Objects with Differences

  • Selected Objects that are Identical

  • Object Property Differences

  • Data Differences Summary

  • Data Differences Fields Compared

  • Data Differences

  • Macro Differences

  • Module Differences

  • Module Identical Procedures

  • Module Printout

  • Comparison Errors

  • List of Reports


Report: Module Differences between Databases

Module Differences

This report shows all the differences between the selected modules:

  • All Module Identical Procedures (Form, report and Standard Module differences)

  • Standard Module Identical Procedures

  • Form Module Identical Procedures

  • Report Module Identical Procedures

Module Differences Report

This report only displays the blocks of code that differ. If your code is large and complex, use this report with Module Code report to determine the complete context of each block of code.

See Also

  • Object Comparison Reports

  • Summary of Database Differences

  • Objects in Both Databases

  • Objects Not in One Database

  • Selected Objects with Differences

  • Selected Objects that are Identical

  • Object Property Differences

  • Data Differences Summary

  • Data Differences Fields Compared

  • Data Differences

  • Macro Differences

  • Macro Lines

  • Module Identical Procedures

  • Module Printout

  • Comparison Errors

  • List of Reports


Report: Module Identical Procedures Report

Module Identical Procedures Report

This report shows all the procedure names with no differences for modules that have other differences. If a module has no differences at all, its procedures are not listed.

Four reports available:

  • All Module Differences

  • Standard Module Differences

  • Form Module Differences

  • Report Module Differences

Identical Procedures Report

See Also

  • Object Comparison Reports

  • Summary of Database Differences

  • Objects in Both Databases

  • Objects Not in One Database

  • Selected Objects with Differences

  • Selected Objects that are Identical

  • Object Property Differences

  • Data Differences Summary

  • Data Differences Fields Compared

  • Data Differences

  • Macro Differences

  • Macro Lines

  • Module Differences

  • Module Printout

  • Comparison Errors

  • List of Reports


Report: Module Printout between Databases

Module Printout

These reports show the complete source code for the selected modules. Along with the code, the report displays line numbers, which start at 1 for each procedure. These line numbers are referenced in the Module Differences reports.

Six reports are available:

  • Module Code from Database 1

  • Module Code from Database 2

  • Form Module Code from Database 1

  • Form Module Code from Database 2

  • Report Module Code from Database 1

  • Report Module Code from Database 2

Module Printout Report

See Also

  • Object Comparison Reports

  • Summary of Database Differences

  • Objects in Both Databases

  • Objects Not in One Database

  • Selected Objects with Differences

  • Selected Objects that are Identical

  • Object Property Differences

  • Data Differences Summary

  • Data Differences Fields Compared

  • Data Differences

  • Macro Differences

  • Macro Lines

  • Module Differences

  • Module Identical Procedures

  • Comparison Errors

  • List of Reports


Report: Comparison Errors

Comparison Errors

This report shows any errors encountered by Total Access Detective during the comparison process. You should always check this report to ensure that all objects were correctly compared.

Errors Report

See Also

  • Object Comparison Reports

  • Summary of Database Differences

  • Objects in Both Databases

  • Objects Not in One Database

  • Selected Objects with Differences

  • Selected Objects that are Identical

  • Object Property Differences

  • Data Differences Summary

  • Data Differences Fields Compared

  • Data Differences

  • Macro Differences

  • Macro Lines

  • Module Differences

  • Module Identical Procedures

  • Module Printout

  • List of Reports


Report: List of Reports

List of Reports

There is a system report listing the available reports and their export file names which are used when you export the report to a format like PDF, HTML, etc.

List of Reports

See Also

  • Object Comparison Reports

  • Summary of Database Differences

  • Objects in Both Databases

  • Objects Not in One Database

  • Selected Objects with Differences

  • Selected Objects that are Identical

  • Object Property Differences

  • Data Differences Summary

  • Data Differences Fields Compared

  • Data Differences

  • Macro Differences

  • Macro Lines

  • Module Differences

  • Module Identical Procedures

  • Module Printout

  • Comparison Errors


License Agreement

PLEASE READ THE FMS SOFTWARE LICENSE AGREEMENT. YOU MUST AGREE TO BE BOUND BY THE TERMS OF THIS AGREEMENT BEFORE YOU CAN INSTALL OR USE THE SOFTWARE.

IF YOU DO NOT ACCEPT THE TERMS OF THE LICENSE AGREEMENT FOR THIS OR ANY FMS SOFTWARE PRODUCT, YOU MAY NOT INSTALL OR USE THE SOFTWARE. YOU SHOULD PROMPTLY RETURN ANY FMS SOFTWARE PRODUCT FOR WHICH YOU ARE UNWILLING OR UNABLE TO AGREE TO THE TERMS OF THE FMS SOFTWARE LICENSE AGREEMENT FOR A REFUND OF THE PURCHASE PRICE.

Ownership of the Software

The enclosed software program (“SOFTWARE”) and the accompanying written materials are owned by FMS, Inc. or its suppliers and are protected by United States copyright laws, by laws of other nations, and by international treaties. You must treat the SOFTWARE like any other copyrighted material except that you may make one copy of the SOFTWARE solely for backup or archival purpose, and you may transfer the SOFTWARE to a permanent storage device.

Grant of License

The SOFTWARE is available on a per license basis. Licenses are granted on a PER USER basis. For each license, one designated person can use the SOFTWARE on one computer at a time.

Other Limitations

Under no circumstances may you attempt to reverse engineer this product. You may not rent or lease the SOFTWARE, but you may transfer the SOFTWARE and the accompanying written materials on a permanent basis provided you retain no copies and the recipient agrees to the terms in this SOFTWARE License. Ownership transfers must be reported to FMS, Inc. in writing and are not accepted if the original developer already distributed applications using the SOFTWARE.

Transfer of License

If your SOFTWARE is marked “NOT FOR RESALE”, you may not sell or resell the SOFTWARE, nor may you transfer the FMS Software license.

If your SOFTWARE is not marked “NOT FOR RESALE,” you may transfer your license of the SOFTWARE to another user or entity provided that:

  1. the recipient agrees to all terms of the FMS Software License Agreement;

  2. you provide all original materials including software disks or compact disks, and any other part of the SOFTWARE’s physical distribution to the recipient;

  3. you remove all installations of the SOFTWARE;

  4. you notify FMS, in writing, of the ownership transfer.

Limited Warranty

If you discover physical defects in the media on which this SOFTWARE is distributed, or in the related manual, FMS, Inc. will replace the media or manual at no charge to you, provided you return the item(s) within 60 days after purchase.

ALL IMPLIED WARRANTIES ON THE MEDIA AND MANUAL, INCLUDING IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE LIMITED TO SIXTY (60) DAYS FROM THE DATE OF PURCHASE OF THIS PRODUCT.

Although FMS, Inc. has tested this program and reviewed the documentation, FMS, Inc. makes no warranty or representation, either expressed or implied, with respect to this SOFTWARE, its quality, performance, merchantability, or fitness for a particular purpose. As a result, this SOFTWARE is licensed “AS-IS”, and you are assuming the entire risk as to its quality and performance.

IN NO EVENT WILL FMS, INC. BE LIABLE FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES RESULTING FROM THE USE, OR INABILITY TO USE THIS SOFTWARE OR ITS DOCUMENTATION.

THE WARRANTY AND REMEDIES SET FORTH IN THIS LIMITED WARRANTY ARE EXCLUSIVE AND IN LIEU OF ALL OTHERS, ORAL OR WRITTEN, EXPRESSED OR IMPLIED.

Some states do not allow the exclusion or limitation of implied warrantees or liability for incidental or consequential damages, so the above limitations or exclusions may not apply to you. This warranty gives you specific legal rights; you may also have further rights that vary from state to state.

U.S. Government Restricted Rights

The SOFTWARE and documentation are provided with RESTRICTED RIGHTS. Use, duplication, or disclosure by the Government is subject to restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in Technical Data and Computer Software clause at DFARS 252.227-7013 or subparagraphs (c) (1) and (2) of the Commercial Computer Software - Restricted Rights at 48 CFR 52.227-19, as applicable.

Manufacturer is FMS Inc., Vienna, Virginia.

Printed in the USA.

Total Access Detective is copyright Ó by Financial Modeling Specialists, Inc. All rights reserved.

Microsoft, Microsoft Access, Microsoft Excel, Microsoft Word, Microsoft Windows, Visual Basic,

and Visual Basic for Applications are registered trademarks of Microsoft Corporation.

All other trademarks are trademarks of their respective owners.


Comparing Access Data Projects

Total Access Detective can compare native Access objects in Access Data Projects (ADPs and ADEs), including: forms, reports, pages, macros, modules, and command bars. It cannot, however, compare objects that exist in SQL Server, such as tables, views, and diagrams. When comparing ADPs, you must run the Total Access Detective Prepare process on each ADP. ADPs were deprecated by Access 2013, so this is not available in the Total Access Detective 2013 and later versions.

See Also

  • Running Total Access Detective

  • Comparing Databases on a Network

  • Comparing Password-Protected Databases

  • Comparing Databases with Workgroup Security


Comparing Databases on a Network

Total Access Detective allows you to compare databases residing on a network drive, but we recommend documenting local copies of these databases for two reasons:

  1. When you compare a database, you don't want other users opening or changing objects. Total Access Detective cannot compare objects that are opened or locked by others.

  2. Performance over a network is substantially slower than a local drive. Total Access Detective is a disk-intensive program—it may need to open objects in design view and read properties and/or compare data records. Because of this, running across a network connection may cause slower performance and may affect other users on the network.

See Also

  • Running Total Access Detective

  • Comparing Access Data Projects

  • Comparing Password-Protected Databases

  • Comparing Databases with Workgroup Security


Comparing Databases with Workgroup Security

Total Access Detective can run database comparison on databases with Workgroup security provided that:

  1. Both databases use the same workgroup security file (*.MDW).

  2. The user group has open/run permissions for the database (not necessary for specific objects, just needed at the database level).

  3. The databases are not set to "Read Only".

Follow these steps to compare two secured databases:

  1. Open one of the Secured databases using the Workgroup Security file.

  2. Close the database, but do not exit Access (choose File, Close Database)

  3. Open TADetect.accdb (or TADetect.mdb version 2003 or earlier), which is located in Total Access Detective’s installation folder.

See Also

  • Running Total Access Detective

  • Comparing Databases on a Network

  • Comparing Access Data Projects

  • Comparing Password-Protected Databases


Comparing Password-Protected Databases

When comparing two objects in the same database, Total Access Detective can compare all object types, regardless of whether the database is protected by a password.

When comparing two databases, simply provide the password for each and all their objects can be compared.

See Also

  • Running Total Access Detective

  • Comparing Databases on a Network

  • Comparing Access Data Projects

  • Comparing Databases with Workgroup Security

  • System Requirements

  • Instructions for International Users

  • Startup Errors


Comparison Options

Depending on the object type that you select for comparison, additional comparison options may be available:

  • Table and Query Comparison Options

  • Data Comparison Options

  • Record Identifier

  • Field Comparison

  • Documentation

  • Display

  • Numerical Accuracy

  • Form and Report Comparison Options

  • Module Comparison Options

See Also

  • Starting the Object Comparison Wizard

  • Selecting Objects for Comparison

  • Property Comparison Results

  • Data Comparison Results

  • Macro and Module Comparison Results

  • Viewing Last Analysis

  • Text Comparison


Object Match then Line-by-Line Comparisons

Total Access Detective flags procedures (or sub-macros) that exist in one module (macro) and not the other.

For identically named procedures and macros, Total Access Detective conducts a line-by-line comparison. When lines differ, the different lines in both objects are shown. If a resync occurs before the end of the procedure, the last line of each block is shown so you can see they are identical. This technique clearly reveals new, modified, and deleted lines of code.

For procedures with completely different code (an inability to resync), it tells you they are completely different rather than listing every line.

Module Comparison Results

For every difference, the procedure name is listed followed by each version of it in each module. Differences in the sort order of the procedures are not documented, since the order is not important.

The Identical Procedures tab lists all the procedures that had no differences.

See Also

  • Module Comparison Options

  • Property Comparison Results

  • Data Comparison Results

  • Macro and Module Comparison Results

    • Macro and Module Comparison Reports

    • Embedded Macro Differences

  • Viewing Last Analysis

  • Text Comparison


Selecting Objects for Comparison

Select the object type from the drop down list box:

Then, specify the names of the two objects to compare, set comparison options, and click [Run].

Permissions

In order to compare objects, Total Access Detective needs to open them in design mode. For Total Access Detective to do this, you must have Read Design permission on the objects you are comparing.

Comparison Options

Depending on the object type that you select, different Comparison Options may be available.

See Also

  • Starting the Object Comparison Wizard

  • Comparison Options

  • Property Comparison Results

  • Data Comparison Results

  • Macro and Module Comparison Results

  • Viewing Last Analysis

  • Text Comparison


Text Comparison Errors

Text Comparison Warning

The text comparison form uses the Microsoft rich text control. It may not load due to a Microsoft Internet Explorer security setting. If this happens, this form appears when running the Text Comparison:

Text Comparison Security Setting Warning

Read the instructions on the screen since it may be different from the example above.

There is a link to a Microsoft Knowledgebase article and a button to update your registry setting. The problem should be fixed when you press the [Update Registry Setting] button.

The registry change may fail if you do not have administrator rights to the registry hive of the local machine. If so, this form appears:

Options if Registry Change Failed

Press the [Continue] button to run the text comparison feature. It will load a less full featured form. You can check the [Don’t Ask Again] option to make this permanent.

Press [Cancel] if you do not want to continue. You can then fix the registry entry and try again.

See Also

  • Text Comparison

  • Text Comparison Options

  • Text Comparison Results


Upgrading from Previous Versions

Just as multiple versions of Access can reside on the same machine, multiple versions of Total Access Detective can exist on the same machine provided that they are installed in separate directories.

Note that only one version from Access/Office 2016 onwards can be installed on a machine, so Total Access Detective also follows this requirement. If you have Total Access Detective 2016 installed, when you install Total Access Detective 2026, the 2016 will no longer be available.

Each version of Total Access Detective is a completely separate program and does not share any files with other versions. If you are no longer using any previous versions of Microsoft Access, you can remove the older version of Total Access Detective from your machine. See Uninstalling Total Access Detective for details.